# -*- coding: utf-8 -*-
"""
     File: descartes.py
     einfache Funktionen zur Analytischen Geometrie
     WS, 2015-03-29
     
     Vers. 0.08: erster Schritt mit internen float-Methoden
     Vers. 0.09: Methode abstandPP neu
     (muss noch intensiv getestet werden!!!!)
     Vers. 0.10: Bug in schnittEE beseitigt (muehsam)
     Vers. 0.11: Methode dreieck, dreieckFlaeche, dreieckEbeneNF, vecAdd
     Vers. 0.12: Methode viereckFlaeche, tetraederVol, pyramidenHoehe, pyramidenVol
     Vers. 0.13: Methode kugel4P, gen_row_from_point
     Vers. 0.14: Methode kreis
     Vers. 0.15: Bug in Funktion _ggt_ beseitigt!!!
     Vers. 0.16: Methode pol (bestimmt Pol P)
     Vers. 0.17: Methode schnittKE modifiziert => liefert 4 Punkte auf Kreislinie
     Vers. 0.18: Bestimmung der 4 Punkte auf Kreislinie ausgelagert in Methode bestimmeKreisPunkte,
                 Bug in schnittKK beseitigt    
     Vers. 0.19: Der FormatString >_descartesFloat2StrFormat_< legt das Format der Umwandlung von Float nach Str fest
                 Klasse PunktRep
                 Methode vecLi2str
                 Methode str2vecLi
                 bedingt Aenderungen in  ===>> funcInter.py  <<===
     Vers. 0.20: Methode strecke
     
    --------------------------------------
       
"""
###################################################################
import math


# Format-String fuer Konvertierung
_descartesFloat2StrFormat_ = "%16.12f"
###################################################################

def _ggt_(i,j):
    if  nullTest(j):
        return i
    else:
        return _ggt_(j, i%j)    

##def _ggt_(i,j):
##    while not _nullTest_(j):
##        h = i % j
##        i = j
##        j = h        
##    return i # => letzter j-Wert aus Schleife

def ggt(i,j):
##    magic = "<type 'int'>"
##    i_type = str(type(i))
##    j_type = str(type(j))    
##    if not(i_type == magic):
##        return 0
##    if not(j_type == magic):
##        return 0
    i = float(i) # int(i)
    j = float(j)  # int(j)
    return _ggt_(i,j) # 



def GGT(i,j,k):
    tmp = ggt(j,k)
    return ggt(i,tmp)


###################################################################
class PunktRep:
    def __init__(self,_punkt_):
        self.punkt = []
        self.maximaPunkt2Li = []
        self.geoPunkt2Str = ''
        self.dim = 0
        if len(_punkt_) > 0:
            self.punkt = _punkt_
            self.dim = len(self.punkt)
            
        
    def setPoint(self,_punkt_):
        self.punkt = _punkt_
        self.dim = len(self.punkt)
        

    def getPunktList(self):
        return self.maximaPunkt2Li


    def getPunktString(self):
        return self.geoPunkt2Str


    def punkt2List(self,breite=18,nachKomma=14):
        """konvertiert Punkt/Vektor in Str-Darstellung"""
        _format_ = "%" + str(breite) + "." + str(nachKomma) + "f"
        #print format        
        for i in range(len(self.punkt)):
            #erg = "%6.3f" % punkt[i]
            erg = _format_ % self.punkt[i]
            self.maximaPunkt2Li.append( erg )
        #print self.maximaPunkt2Li
        return self.maximaPunkt2Li
        
  
    def punkt2GeoStr(self,breite=18,nachKomma=14):
        """konvertiert Punkt/Vektor in Str-Darstellung"""
        _format_ = "%" + str(breite) + "." + str(nachKomma) + "f"
        #print format        
        strRep = '(['
        for i in range(len(self.punkt)):
            #erg = "%6.3f" % punkt[i]
            erg = _format_ % self.punkt[i]
            strRep = strRep +  erg + ','
        self.geoPunkt2Str = strRep[:-1] + '])'
        #print self.geoPunkt2Str
        return self.geoPunkt2Str
        
###################################################################
def vecLi2str(vec):
    """
    IN: ['  1.89473684210526', '  1.52631578947368', '  0.00000000000000']
    OUT:  ([  1.00000000000000,  0.33333333333333,  0.00000000000000])
    """
    strRep = '(['
    for i in range(len(vec)):            
            strRep = strRep +  str(vec[i]) + ','            
    _ret_ = strRep[:-1] + '])'
    return _ret_

def str2vecLi(strRep):
    """
    IN: ([  1.00000000000000,  0.33333333333333,  0.00000000000000])
    OUT: ['  1.89473684210526', '  1.52631578947368', '  0.00000000000000']
    """
    _punktList_ = []
    #print strRep
    strList = strRep.split(',')
    i = 1
    for element in strList:
        if i == 1:
            _punktList_.append( element[2:].strip()    )
        if i == 2:
            _punktList_.append(  element.strip()       )
        if i == 3:
            _punktList_.append(  element[:-2].strip()  )
        i = i + 1
    # print _punktList_    
    return _punktList_


def punkt2str(punkt,breite=18,nachKomma=14):
    """konvertiert Punkt in Str-Darstellung;
       gibt Liste retour:
       - punkt2li: Darstellung fuer Maxima
       - punkt2str: Darstellung fuer pyGeo
    """
    Punkt = PunktRep(punkt)
    punkt2str = Punkt.punkt2GeoStr(breite,nachKomma)
    return punkt2str

def vec2str(vec,breite=18,nachKomma=14):
    """konvertiert Vektor in Str-Darstellung;
       gibt Liste retour:
       - punkt2li: Darstellung fuer Maxima
       - punkt2str: Darstellung fuer pyGeo
    """    
    Vektor = PunktRep(vec)
    punkt2li  = Vektor.punkt2List(breite,nachKomma)
    return punkt2li

def vec2float(vec):
    floatRep = []    
    for i in range(len(vec)):
        floatRep.append(float(vec[i]))
    return floatRep

###################################################################

def spurpunkte(aufpunkt,richtvec):
    """liefert Spurpunkte der Geraden g: x = aufpunkt + r * richtvec
        mit den ["yz","xz","xy"]-Koordinatenebenen
        ret enthaelt die Schnittpunkte mit ["yz","xz","xy"]-Ebene
        (in dieser Reihenfolge)
    """
    ret = []
    ebene = ["yz","xz","xy"]
##    for element in ebene:
##        print element
    for i in range(len(ebene)):        
        # gleichung: 0  =  aufpunkt[i] + "  + r * " + richtvec[i]
        # also: -aufpunkt[i] = r * " + richtvec[i]
        erg = _solveLin_((-1)*float(aufpunkt[i]),float(richtvec[i]))
        if erg[0] == "ein":
            sp = generateSpurpunkt(aufpunkt,richtvec,erg[1])
            #print "Schnittpunkt mit " + ebene[i] + "-Koordinatenebene: " + str(sp)
            ret.append(sp)
        else:
            #print "Kein Schnittpunkt mit der " + ebene[i] + "-Koordinatenebene"
            leer = []
            ret.append(leer)
    # ret enthaelt die Schnittpunkte mit ["yz","xz","xy"]-Ebene (in dieser Reihenfolge)
    return ret


def generateSpurpunkt(aufpunkt,uvec,r):
    """ IN: Aufpunkt, Richtungsvektor uvec, r
        OUT: Spurpunkt
    """
    sp = []
    for i in range(len(uvec)):
        koord = float(aufpunkt[i]) + r * float(uvec[i])
        sp.append( str(koord) )
    return sp


def spurpunkt(nvec,d,achse):
    """liefert Spurpunkt der i-ten Achse (i=1,2,3) bzw. [] (= kein Spurpunkt)"""
    if not(achse in [1,2,3]):
        return []
    ret = ['0','0','0']
    xyz = ['x','y','z']
    n_i = float(nvec[achse-1])
    dnum = float(d)
    if (n_i != 0.0):
	ret[achse-1] = str(dnum / n_i)
	return ret
    else:
        return []

def generateAufpunkt(a,b,c):
    """ IN: 3 Spurpunkte
        OUT: Aufpunkt
    """
    try:
        float(a[0])
        return a
    except:
        pass

    try:
        float(b[1])
        return b
    except:
        pass
       
    try:
        float(c[2])
        return c
    except:
        return []     # kann eigentlich nicht eintreten . . .    


def punkt2maxima(_punkt_,_t_= 1):
    """erzeugt aus den Punktkoordinaten die Maxima-Darstellung"""
    import string
    #print "punkt2maxima: " + str(punkt)
    try:
        punkt = str2vecLi(_punkt_)
    except:
        punkt = _punkt_
    
    magic = "<type 'float'>"
    typ = str(type(punkt[0]))
##    if string.find(magic,typ) != -1:
##        punkt = punkt2str(punkt)
    if typ.find(magic) != -1:
        punkt = vec2str(_punkt_)
        
    if len(punkt) > 0:
        maxima_rep = "matrix([" + punkt[0] + ',' + punkt[1]  + ',' + punkt[2] + "])"
        if _t_ == 1:
            maxima_rep = "transpose(" + maxima_rep + ")"
        return maxima_rep
    else:
        return ""




def ebeneNF(punktListe):
    aufpunkt = punktListe[0]
    uvec = genRichtVec(aufpunkt,punktListe[1])
    vvec = genRichtVec(aufpunkt,punktListe[2])
    nvec = crossProdukt(uvec,vvec)
    _d_ = skalarProdukt(aufpunkt,nvec)
    return (nvec,_d_)

def punkt2Gerade(punktListe):
    aufpunkt = punktListe[0]
    uvec = genRichtVec(aufpunkt,punktListe[1])
    return (aufpunkt,uvec)    
    

def rvec1(vec):
    """erzeugt aus einem Normalenvektor einen Richtungsvektor"""
    ret = ['0','0','0']
    if (vec[0] != '0') and (vec[0] != '0.0') and (vec[0] != '-0') and (vec[0] != '-0.0'):
        ret[1] = str( (-1) * float(vec[0]) ) 
        ret[0] = vec[1]
        return ret
    elif (vec[1] != '0') and (vec[1] != '0.0') and (vec[1] != '-0') and (vec[1] != '-0.0'):
        ret[0] = str( (-1) * float(vec[1]) ) 
        ret[1] = vec[0]
        return ret        
    elif (vec[2] != '0') and (vec[2] != '0.0') and (vec[2] != '-0') and (vec[2] != '-0.0'):        
        ret[1] = str( (-1) * float(vec[2]) ) 
        ret[2] = vec[1]
        return ret        
    else:
        return vec

def rvec2(vec):
    """erzeugt aus einem Normalenvektor einen (zweiten) Richtungsvektor"""    
    ret = ['0','0','0']
    if (vec[0] != '0') and (vec[0] != '0.0') and (vec[0] != '-0') and (vec[0] != '-0.0'):
        ret[2] = str( (-1) * float(vec[0]) ) 
        ret[0] = vec[2]
        return ret
    elif (vec[1] != '0') and (vec[1] != '0.0') and (vec[1] != '-0') and (vec[1] != '-0.0'):
        ret[2] = str( (-1) * float(vec[1]) ) 
        ret[1] = vec[2]
        return ret        
    elif (vec[2] != '0') and (vec[2] != '0.0') and (vec[2] != '-0') and (vec[2] != '-0.0'):        
        ret[0] = str( (-1) * float(vec[2]) ) 
        ret[2] = vec[0]
        return ret        
    else:
        return vec

def abcFormel(a,b,c):
    return _abcFormel_(float(a), float(b), float(c) )

def betrag(vec):
    """liefert Betrag/Laenge des Vektors"""
    #fvec = vec2float(vec)
    return _betrag_( vec2float(vec) )


def vecAdd(uvec,vvec):
    return _vecAdd_( vec2float(uvec), vec2float(vvec) )


def skalarMult(k,vec):
    """liefert k*vec"""    
    rvec = _skalarMult_( float(k), vec2float(vec) )    
    return vec2str(rvec)


def skalarProdukt(uvec,vvec):
    """liefert Skalarprodukt von uvec * vvec"""    
    return _skalarProdukt_( vec2float(uvec), vec2float(vvec) )



def winkel(uvec,vvec,sinus=0):    
    alpha = _winkel_(vec2float(uvec),vec2float(vvec),sinus)
    if alpha:
        ret = _descartesFloat2StrFormat_ % alpha
        return ret
    else:
        return None

def winkelSin(uvec,vvec):
    """liefert Winkel zwischen uvec und vvec"""
    return winkel(uvec,vvec,1)


def genRichtVec(a_punkt,b_punkt):
    """ IN: zwei Punkte AB
        OUT: Richtungsvektor AB
    """
    rvec = []
    for i in range(len(a_punkt)):
        koord = float(b_punkt[i]) - float(a_punkt[i])
        rvec.append(str(koord) )
    return rvec


def crossProdukt(uvec,vvec):
    """liefert Kreuzprodukt von uvec x vvec"""
    vec = []
    vec.append((  str( det2(uvec,vvec,1,2) ) ) )
    vec.append( ( str( det2(uvec,vvec,2,0) ) ) ) 
    vec.append( ( str( det2(uvec,vvec,0,1) )  ) )                
    return vec

def det2(uvec,vvec,i,j):
    """Bestimmt Determinante fuer Kreuzprodukt"""
    return float(uvec[i]) * float(vvec[j])  -  float(uvec[j]) * float(vvec[i])

def koordinatenform(nvec,_d_):
    """liefert die Koordinatenform in menschenlesbarer Form"""
    #return nvec[0] + "*x + " + nvec[1] + "*y + " + nvec[2] + "*z = " + str(_d_)
    ret = ""
    xvec = ["x","y","z"]
    for i in range(len(nvec)):
        if not nullTest(nvec[i]):
            if i < 1:
                ret = ret + str(nvec[i]) + "*" + str(xvec[i]) 
            else:
                if (float(nvec[i]) > 0):
                    ret = ret + " + "  + str(nvec[i]) + "*" + str(xvec[i])
                else: # float(nvec[i]) < 0
                    ret = ret + " "  + str(nvec[i]) + "*" + str(xvec[i])
    ret = ret + " = " + str(_d_)
    return ret


def linearAbhaengig(uvec,vvec):
    return _linearAbhaengig_( vec2float(uvec), vec2float(vvec) )


###################################################################
##############  Vektor  <=>  Matrix  ##############

def toMatrix(vec1,_d1_,vec2,_d2_):
    mat = []
    zeile = []
    for i in range(len(vec1)):
        zeile.append(float(vec1[i]))
    zeile.append(float(_d1_) )                
    mat.append(zeile)
    zeile = []
    for i in range(len(vec2)):
        zeile.append(float(vec2[i]))
    zeile.append(float(_d2_) )                
    mat.append(zeile)
    return mat

def toMatrix3(vec1,vec2,abvec):
    mat = []
    zeile = []
    for i in range(len(vec1)):
        zeile = []
        zeile.append(float( vec1[i]) )
        zeile.append(float( vec2[i]) )
        zeile.append(float(abvec[i]) )
        mat.append(zeile)    
    return mat        


def vektorQuadrat(vec):
    if nullVektorTest(vec):
        return 0
    else:
        return skalarProdukt(vec,vec)
    
###################################################################

def gen_row_from_point(_p_):
    # fuer kugel4P: erzeugt eine Zeile der Koeffizientenmatrix aus einem Punkt
    vec_ = []
    vec_.append(1.0)
    vec = vec2float(_p_)
    res = (-1) *  vektorQuadrat(vec)
    for zahl in vec:
        vec_.append(zahl)
    vec_.append( res )
    return vec_

def kugel4P(p0,p1,p2,p3):
    """In Anlehnung an: http://www.arndt-bruenner.de/mathe/scripts/kugel4p.htm
    (von Arndt Brünner)"""
    matrix = []
    # erzeugt wird eine 4x5 - Matrix    
    matrix.append( gen_row_from_point(p0)  )
    matrix.append( gen_row_from_point(p1)  )
    matrix.append( gen_row_from_point(p2)  )
    matrix.append( gen_row_from_point(p3)  )    
    
    if _gauss_jordan_(matrix): #
        #print matrix
        mvec = []
        for i in range(3):
            m = (-0.5) * matrix[i+1][4]
            mvec.append(m)
        #print mvec
        rad_quad = vektorQuadrat(mvec) - matrix[0][4] # mvec * mvec - A
        _rad_ = math.sqrt(rad_quad)
        #print _rad_
        mvec = vec2float( vec2str(mvec) )
        return ( mvec , _rad_)  # return-Format von kugel4P: (mvec,_rad_)
    else:
        return None

def kreis(objectName,a,b,c):
    """objectName: Name in Maxima,

    Idee: a,b,c bilden ein Dreieck,
    der Kreis ist dann der Umkreis (= circumscribed circle)

    IN: Kreis durch drei Punkte a,b,c
    OUT: Mittelpunkt M, Radius R"""
    
    ret = []    
    
    cvec = genRichtVec(a,b)
    bvec = genRichtVec(a,c)
    avec = genRichtVec(b,c)
    #print cvec, bvec, avec
    
    nvec = crossProdukt(cvec,bvec) # Normalenvektor, steht senkrecht auf Kreisebene
    #print nvec
    
    # Mittelsenkrechte auf AB: m_c + r * senk_ab    
    senk_ab = crossProdukt(nvec,cvec)
    c_halbe = skalarMult(0.5,cvec)
    m_c = vecAdd(a , c_halbe)
    
    # Mittelsenkrechte auf AC: m_b + r * senk_ac
    senk_ac = crossProdukt(nvec,bvec)    
    b_halbe = skalarMult(0.5,bvec)
    m_b = vecAdd(a , b_halbe)

    # Schnittpunkt der Mittelsenkrechten = Kreismittelpunkt
    erg = schnittGG(m_c,senk_ab,m_b,senk_ac)
    # Beispiel: erg == ['sc', ['  0.3333', '  0.3333', '  0.3333']]
    if erg[0] == 'sc':
        mittelp = erg[1]  # vec2float( erg[1] )
        ret.append(mittelp)
        #print mittelp

        # Radius: Abstand Mittelpunkt, Punkt A / B  / C (da Umkreis)
        rad = abstandPP(a,mittelp)
        ret.append(rad)
        #print rad
        return ret
    
    else: # erg[0] != 'sc' ==>> kein Schnittpunkt!!!
        return ret


def strecke(objectName,a,b):
    """objectName: Name in Maxima,
    a,b: Punkte der Strecke"""
    
    abvec = genRichtVec(a,b)
        
    ret = []
    seite_ab = _descartesFloat2StrFormat_ % betrag( abvec )
    #print seite_ab
    ret.append("Laenge AB=")
    ret.append( seite_ab )
    return ret


def dreieckFlaeche(a,b,c):
    """a,b,c: Punkte des Dreiecks"""    
    cvec = genRichtVec(a,b)
    bvec = genRichtVec(a,c)
    
    cp = crossProdukt(cvec,bvec)

    return 0.5 * betrag( cp )


def dreieckEbeneNF(a,b,c):
    """a,b,c: Punkte des Dreiecks
    konstruiert Ebene in Normalform zum Dreieck"""        
    cvec = genRichtVec(a,b)
    bvec = genRichtVec(a,c)
    #print cvec,bvec
    nvec = crossProdukt(cvec,bvec) # Normalenvektor
    
    nvec = vec2float(nvec)
    #print nvec
    if nullVektorTest(nvec):
        return None
    else:
        #print "jetzt ggt"
        ggt_nvec = GGT( nvec[0],nvec[1],nvec[2] )                
        
        if ggt_nvec > 1:
            nvec[0] = str( float(nvec[0])/ggt_nvec )
            nvec[1] = str( float(nvec[1])/ggt_nvec )
            nvec[2] = str( float(nvec[2])/ggt_nvec )
        
        _d_ = skalarProdukt(nvec,a)  # Abstand _d_
        #print _d_
        #print koordinatenform(nvec,_d_)
        
        return (nvec,_d_)  # return-Format von ebeneNF: (nvec,_d_)


    
def dreieck(objectName,a,b,c):
    """objectName: Name in Maxima,
    a,b,c: Punkte des Dreiecks"""

    area = dreieckFlaeche(a,b,c)
    area_str = _descartesFloat2StrFormat_ % area
    
    cvec = genRichtVec(a,b)
    bvec = genRichtVec(a,c)
    avec = genRichtVec(b,c)

    mcvec = skalarMult(-1.0,cvec)
    #print mcvec
    alpha = winkel(cvec,bvec)
    beta = winkel(mcvec,avec)
    gammaF = 180 - (float(alpha) +  float(beta) )
    gamma = _descartesFloat2StrFormat_ % gammaF
    
    # Bestimmung Seitenhalbierende
    a_halbe = skalarMult(0.5,avec)
    m_a = vecAdd(b , a_halbe)
    b_halbe = skalarMult(0.5,bvec)
    m_b = vecAdd(a , b_halbe)
    #c_halbe = skalarMult(0.5,cvec)
    #m_c = vecAdd(a , c_halbe)
    m_a_vec = genRichtVec(a,m_a)
    m_b_vec = genRichtVec(b,m_b)
    # Bestimmung Schwerpunkt
    ga_gb = schnittGG(a,m_a_vec,b,m_b_vec)
    
    ret = []
    ret.append("Umfang U=")
    um = _descartesFloat2StrFormat_ % (betrag( avec ) + betrag( bvec ) + betrag( cvec ) )
    seite_a = _descartesFloat2StrFormat_ % betrag( avec )
    seite_b = _descartesFloat2StrFormat_ % betrag( bvec )
    seite_c = _descartesFloat2StrFormat_ % betrag( cvec )    
    ret.append( um )
    ret.append("Fläche A=")
    ret.append( area_str )
    ret.append("Seite a=")
    ret.append( seite_a )
    ret.append("Seite b=")
    ret.append( seite_b )
    ret.append("Seite c=")
    ret.append( seite_c )
    ret.append("Winkel alpha=")
    ret.append( alpha )
    ret.append("Winkel beta=")
    ret.append( beta )    
    ret.append("Winkel gamma=")
    ret.append( gamma )    
    if ga_gb[0] == "sc": # Schnittpunkt zw Seitenhalbierenden
        ret.append("Schwerpunkt S_" + objectName)
        ret.append( ga_gb[1] ) # ga_gb[1] ==>> Schwerpunkt
        ret.append('S_' + objectName + ' : ' +  punkt2maxima( ga_gb[1] ) ) # ga_gb[1] ==>> Schwerpunkt
    return ret

def viereckFlaeche(a,b,c,d):
    """a,b,c,d: Punkte des Vierecks
    Flaecheninhalt 4eck = 3eck1 + 3eck2  """
    area1 = dreieckFlaeche(a,b,c)
    area2 = dreieckFlaeche(c,d,a)
    return (area1 + area2)


def tetraederVol(a,b,c,d):
    """a,b,c,d: Punkte des Teraeders
    Volumen = = 1/6·|(avec×bvec)·cvec|
    => 1/6 des Volumens des Parallelepipeds """
    
    avec = genRichtVec(a,b)
    bvec = genRichtVec(a,c)
    cvec = genRichtVec(a,d)
    cp = crossProdukt(avec,bvec)    
    erg = skalarProdukt( cp,cvec )
    vol = (1.0/6.0) * abs( erg )
    vol_str = _descartesFloat2StrFormat_ % vol
    return vol_str

def pyramidenHoehe(a,b,c,d,spitze):
    """a,b,c,d,spitze: Punkte der Pyramide
    hoehe = abstand(grundflaeche,spitze) """
    eNF = dreieckEbeneNF(a,b,c)
    hoehe = abstandEP(eNF[0],eNF[1], spitze)
    return hoehe

def pyramidenVol(a,b,c,d,spitze):
    """a,b,c,d,spitze: Punkte der Pyramide
    Volumen = = 1/3 · G · h
    G = viereckige Grundflaeche"""
    grund = viereckFlaeche(a,b,c,d)
    hoehe = pyramidenHoehe(a,b,c,d,spitze)
    vol = (1.0/3.0) * grund * float(hoehe)
    vol_str = _descartesFloat2StrFormat_ % vol
    return vol_str
    
############## Punktprobe
def punktProbeP(punktA,punktB):
    """Punkttest fuer zwei Punkte A und B"""
    if leer(punktA) or leer(punktB):
        print "Punktangabe fehlt . . .",
        return None
    else:
        rvec = genRichtVec(punktA,punktB)
        quadrat = vektorQuadrat(rvec)
        distanz = math.sqrt(quadrat)
        if _nullTest_( distanz ):
            return 1
        else:
            return 0

        
def punktProbeK(m_punkt,rad,punkt):
    """Punktprobe fuer Kugel K und Punkt P"""
    if leer(m_punkt) or leer(punkt):
        print "Punktangabe fehlt . . .",
        return None
    else:
        rvec = genRichtVec(punkt,m_punkt)
        quadrat = vektorQuadrat(rvec)
        mp = math.sqrt(quadrat)
        #quadDistanz = (quadrat - float(rad) * float(rad) )
        distanz = mp - float(rad) 
        if _nullTest_( distanz ):
            return 1
        else:
            return 0
    
def punktProbeE(nvec,_d_,punkt):
    """Punktprobe fuer Ebene E und Punkt P"""
    erg = skalarProdukt(nvec,punkt)
    if _nullTest_( (erg - float(_d_) ) ):
        return 1
    else:
        return 0

def punktProbeG(a_punkt,rvec,punkt):
    """Punktprobe fuer Gerade g und Punkt P"""
    if nullVektorTest(rvec):
        print "Keine Geradengleichung!",
        return None
    elif leer(a_punkt) or leer(punkt):
        print "Punktangabe fehlt . . .",
        return None    
    #print a_punkt,rvec,punkt
    solution = []
    diffvec = []
    for i in range(len(punkt)):    
        diff = float(punkt[i]) -  float(a_punkt[i])
        diffvec.append(str(diff))        
    if nullVektorTest(diffvec):  # a_punkt == punkt
        return 1
    else:
        ## Gleichung: diffvec[i] = s * rvec[i] => linear abhaengig?
        result = linearAbhaengig(diffvec,rvec)
        return result
    
###################################################################
################ Lagebeziehungen
def schnittEE(nvec1,_d1_,nvec2,_d2_):
    """Schnitt zweier Ebenen E und F => muehsam . . ."""
    _debug_ = 0    
    if nullVektorTest(nvec1) or nullVektorTest(nvec2):
        print "Keine Ebenengleichung!"
        return None
    else:
        d1 = float(_d1_) / betrag(nvec1)
        d2 = float(_d2_) / betrag(nvec2)        
        if linearAbhaengig(nvec1,nvec2):
            if _nullTest_( abs(d1) - abs(d2) ):
                if _debug_:                                
                    print "Die Ebenen sind identisch"
                return ["id",nvec1,_d1_]
            else:
                if _debug_:                                
                    print "Die Ebenen sind parallel"
                return ["pa"]
        else:
            rvec = crossProdukt(nvec1,nvec2)
            if nullVektorTest(rvec):
                print "Keine Ebenengleichung!"
                return None
            else:
                try: # rvec vereinfachen
                    ggt_ = GGT( rvec[0],rvec[1],rvec[2] )                    
                    if ggt_ > 1:
                        rvec[0] = str( float(rvec[0])/ggt_ )
                        rvec[1] = str( float(rvec[1])/ggt_ )
                        rvec[2] = str( float(rvec[2])/ggt_ )
                except:
                    pass

                if _debug_:
                    print "Richtungsvektor:",
                    print rvec


                ma = toMatrix(nvec1,_d1_,nvec2,_d2_)
                if _debug_:
                    print "Matrix:",
                    print ma
                                        

                unterMa = []
                import copy  # !!!
                # Pitfall: shallow copy vs. deep copy. 
                # A shallow copy of a list only copies 
                # the first-level elements. 
                # If a list contains nested lists, 
                # a deep copy is necessary to make copies 
                # of the nested lists.
                # URL: http://www.jimbrooks.org/web/python/
                
                pivot = None
                for i  in range(3):
                    unterMa = copy.deepcopy(ma)
                    if _debug_:                    
                        print "Matrix vor Streiche Spalte: " + str(i),    
                        print unterMa
                    
                    _streicheSpalte_(unterMa,i)
                    
                    if not _nullTest_( _det_(unterMa) ):  # _det_(unterMa) != 0    
                        pivot = i
                        break # beende for-Schleife
                    
                    if _debug_:
                        print "Sub Matrix:",    
                        print unterMa
                        print "pivot:", 
                        print pivot
                
                aufPunkt = []
                
                if (pivot >= 0):
                    if _gauss_jordan_(unterMa): # Bestimme Aufpunkt                        
                        for i in range(0,2):
                            if (i == pivot):
                                aufPunkt.append( str(0.0) )                             
                            zahl = _descartesFloat2StrFormat_ % unterMa[i][2]                        
                            #zahl = str(ma[i][3])
                            aufPunkt.append(zahl)
                        
                else:  # pivot = None
                    if _gauss_jordan_(ma): # Bestimme Aufpunkt                    
                        for i in range(0,2):
                            zahl = _descartesFloat2StrFormat_ % ma[i][3]                        
                            #zahl = str(ma[i][3])
                            aufPunkt.append(zahl)
                        aufPunkt.append( str(0.0) )
                        if _debug_:
                            print "Aufpunkt:",
                            print aufPunkt
                    else:
                        if _debug_:
                            print "Matrix singulaer"
                        return ["sg",aufPunkt,rvec]
                if _debug_:                                    
                    print "Die Ebenen schneiden sich:",
                    print aufPunkt,
                    print "+ r *", 
                    print rvec
                return ["sg",aufPunkt,rvec]



def windschief(zeile, mat):
    test = mat[0][2] * zeile[0] + mat[1][2] * zeile[1]
    if _nullTest_(abs(test-zeile[2]) ):
        return 0
    else:
        return 1


def bestimmeSchnittpunkt(mat,a_punkt,uvec):
    if _nullTest_( mat[0][0] ):
        print "Unbekannter Fehler" # Kann eigentlich nicht sein
        return None
    else:
        k = mat[0][2] / mat[0][0]
        s_punkt = []
        for i in range(3):
            erg = float(a_punkt[i]) + k * float(uvec[i]) 
            zahl = _descartesFloat2StrFormat_ % erg
            s_punkt.append( zahl )
        return s_punkt


def schnittGG(a_punkt,uvec,b_punkt,vvec):
    """Schnitt zweier  Geraden g und h (muehsam. . .)"""

    _debug_ = 0    
    if nullVektorTest(uvec) or nullVektorTest(vvec):
        print "Keine Geradengleichung!",
        return None
    elif leer(a_punkt) or leer(b_punkt):
        print "Punktangabe fehlt . . .",
        return None    
    else:    
        if linearAbhaengig(uvec,vvec):
            if punktProbeG(a_punkt,uvec,b_punkt):
                if _debug_:                
                    print "Die Geraden sind identisch"
                return ["id",a_punkt,uvec]
            else:
                if _debug_:                
                    print "Die Geraden sind parallel"
                return ["pa"]
        else:
            abvec = genRichtVec(a_punkt,b_punkt)
            if nullVektorTest(abvec):
                if _debug_:                
                    print "Die Geraden schneiden sich im Aufpunkt"
                return ["sc",a_punkt]
            else:
                ma = toMatrix3(uvec,vvec,abvec)                
                detma = 0
                unterMa = []
                for i  in range(3):
                    unterMa = ma[:]
                    zeile = ma[i]              
                    _streicheZeile_(unterMa,i)
                    if (_nullTest_( _det_(unterMa) ) == 0):  # _det_(matrix) != 0
                        break                        
##                print ma
##                print det3(ma)
##                print unterMa
                if _gauss_jordan_(unterMa): #
                    if windschief(zeile,unterMa):
                        if _debug_:                        
                            print "Die Geraden sind windschief"
                        return ["wi"]
                    else:
                        sPunkt = bestimmeSchnittpunkt(unterMa,a_punkt,uvec)
                        if sPunkt:
                            if _debug_:                            
                                print "Die Geraden schneiden sich, Schnittpunk S: ",
                                #print sPunkt
                            return ["sc",sPunkt]
                        else:
                            return None              
                else:
                    print "Matrix singulär"                        
                    return None



def bestimmeDurchstosspunkt(a_punkt,rvec,nvec,_d_):
    n = 0
    for i in range(3):            
        _d_ = _d_ - float(a_punkt[i]) * float(nvec[i])        
        n  = n +  float(rvec[i]) * float(nvec[i])
    #print _d_,n
    erg = _solveLin_(_d_ , n )
    if erg[0] == "ein":
        k = erg[1]
        return punktAufGerade(k,a_punkt,rvec)
    else:
        return []



def schnittGE(a_punkt,rvec,nvec,_d_):    
    """Schnitt: Gerade g, Ebene E"""
    _debug_ = 0
    if nullVektorTest(nvec):
        print "Keine Ebenengleichung gegeben!"
        return None
    elif nullVektorTest(rvec):
        print "Keine Geradengleichung gegeben!"
        return None
    elif leer(a_punkt):
        print "Punktangabe fehlt . . .",
        return None        
    else:
        erg = skalarProdukt(nvec,rvec)
        if _nullTest_( (erg ) ):
            if punktProbeE(nvec,_d_,a_punkt):
                if _debug_:
                    print "Die Gerade liegt in der Ebene E"
                return ["id",a_punkt,rvec]
            else:
                if _debug_:                
                    print "Die Gerade liegt parallel zur Ebene E"
                return ["pa",]
        else:
            _punkt_ = bestimmeDurchstosspunkt(a_punkt,rvec,nvec,_d_)            
            #print _punkt_
            dPunkt = vec2str(_punkt_)            
            if dPunkt:
                if _debug_:                
                    print "Die Gerade schneidet die Ebene E, Durchstoßpunkt D: ",
                    print dPunkt
                return ["sc",dPunkt]

###################################################################
############### Abstandsprobleme
def abstandPP(a_punkt,b_punkt):
    """Abstand d(A;B) = betrag(vec_a_b) mit vec_a_b = AB"""
    if leer(a_punkt) or leer(b_punkt):
        print "Punktangabe fehlt . . .",
        return None
    vec_a_b = genRichtVec(a_punkt,b_punkt)
    laenge = betrag(vec_a_b)    
    abstand_ = abs( laenge )
    if _nullTest_( abstand_ ):
        abstand = _descartesFloat2StrFormat_ % ( 0.0 )        
    else:
        abstand = _descartesFloat2StrFormat_ % ( abstand_ )        
    return abstand

            
def abstandEP(nvec,_d_,punkt):
    """Abstand d(P;E)"""
    if nullVektorTest(nvec):
        print "Keine Ebenengleichung!",
        return None
    elif leer(punkt):
        print "Punktangabe fehlt . . .",
        return None
    
    laenge = betrag(nvec)    
    erg = skalarProdukt(nvec,punkt)
    abstand_ = abs( (erg - float(_d_) ) * 1/laenge )
    abstand = _descartesFloat2StrFormat_ % ( abstand_ )
    return abstand


def abstandEE(nvec,_d_,punktE2):
    """Abstand d(E;E) => nur bei parallelen Ebenen"""
    return abstandEP(nvec,_d_,punktE2)


def abstandEG(nvec,_d_,a_punkt,uvec):
    """Abstand d(G;E) => nur falls Gerade g und Ebene E parallel => nvec * uvec = 0"""
    if nullVektorTest(uvec):
        print "Keine Geradengleichung!",
        return None
    elif nullVektorTest(nvec):
        print "Keine Ebenengleichung!",
        return None    
    elif leer(a_punkt):
        print "Punktangabe fehlt . . .",
        return None
    
    erg = skalarProdukt(nvec,uvec)
    if _nullTest_( erg ):
        return abstandEP(nvec,_d_,a_punkt)

def abstandGP(a_punkt,rvec,punkt):
    """Abstand d(P;G)
    Idee: Ebene mit nvec = rvec und Aufpunkt punkt
    Bestimme Lotfusspunkt F, 
    Abstand = d(F,punkt) = laenge(F,punkt)"""
    if nullVektorTest(rvec):
        print "Keine Geradengleichung!",
        return None
    elif leer(a_punkt) or leer(punkt):
        print "Punktangabe fehlt . . .",
        return None
        
    _d_ = skalarProdukt(rvec,punkt)
    fussPunkt = schnittGE(a_punkt,rvec,rvec,_d_)[1]
    distanzVektor = genRichtVec(fussPunkt,punkt)
    distanz = _descartesFloat2StrFormat_ %  betrag(distanzVektor)
    return distanz
    


def abstandGG(a_punkt,uvec,b_punkt,vvec):
    """Abstand d(G;G) => nur bei parallelen/windschiefen Geraden!!!"""
    if nullVektorTest(uvec) or nullVektorTest(vvec):
        print "Keine Geradengleichung!",
        return None
    elif leer(a_punkt) or leer(b_punkt):
        print "Punktangabe fehlt . . .",
        return None
    
    erg = schnittGG(a_punkt,uvec,b_punkt,vvec)

    if len(erg) == 1: # Liste leer => kein Schnittpunkt
        if erg[0] == "pa": # parallel
            #print "Abstand:",
            return abstandGP(a_punkt,uvec,b_punkt)
        else:  # windschief: erg[0] == "wi" 
            nvec = crossProdukt(uvec,vvec)
            abvec = genRichtVec(a_punkt,b_punkt)
            distanz = _descartesFloat2StrFormat_ % abs( skalarProdukt(abvec,nvec) / betrag(nvec) )
            #print "Abstand:",
            return distanz
    else:
        print "Schnittpunkt oder identisch . . .",
        return None

def abstandKP(m_punkt,rad,punkt):
    """Abstand d(P;K)
        quadDistanz < 0: Punkt liegt innerhalb der Kugel
        quadDistanz == 0: Punkt liegt auf der Kugel
        quadDistanz > 0: Punkt liegt außerhalb der Kugel
        retour: (quadDistanz, distanz) => Type: (float, str)
    """
    if leer(m_punkt) or leer(punkt):
        print "Punktangabe fehlt . . .",
        return None
    else:
        rvec = genRichtVec(punkt,m_punkt)
        quadrat = vektorQuadrat(rvec)
        mp = math.sqrt(quadrat)
        quadDistanz = (quadrat - float(rad) * float(rad) )
        distanz = _descartesFloat2StrFormat_ % ( mp - float(rad) )                
        return (quadDistanz,distanz)


###################################################################
# Kugel bzw. Kreismethoden


def pol(m_punkt,rad,nvec,_d_):
    """konstruiert zu einer Polarebene E und einer Kugelgleichung den Pol P
       Idee: MP * MF = r^2  (mit F = Durchstosspunkt von M aus auf Polarebene E)
       Pol P auf Gerade g durch M und Richtungsvektor nvec (von Polarebene E) 
    """
    (schnittM, punktF) = schnittGE(m_punkt,nvec,nvec,_d_)    
    if (schnittM == "sc"):
        schnittkreis = schnittKE(m_punkt,rad,nvec,_d_)
        if len(schnittkreis) == 2:
            betrag_nvec = betrag(nvec)
            vecMF = genRichtVec(m_punkt,punktF)
            betrag_vecMF = betrag(vecMF)
            skalarP = rad * rad / (betrag_nvec * betrag_vecMF)
            orientierung = skalarProdukt(vecMF,nvec)
            pvec = skalarMult(skalarP,nvec)
            if (orientierung < 0):
                # pvec umkehren
                pvec = skalarMult((-1.0),pvec)
            polP = vecAdd(m_punkt,pvec)
            return vec2str(polP)
        else: # kein Schnittkreis
            return None
    else: # kein Schnittpunkt zwischen Gerade g durch M und nvec und Ebene E
        return None # kann eigentlich nicht sein!!!
    

def tangentialebene(m_punkt,rad,punkt):
    """
        tangentialebene
        retour: Tangentialebene in Normalform: nvec,_d_
    """
    if leer(m_punkt) or leer(punkt):
        print "Punktangabe fehlt . . .",
        return None
    else:
        nvec = genRichtVec(punkt,m_punkt) # Vektor steht senkrecht auf E
        _d_ = skalarProdukt(punkt,nvec)
        return (nvec,_d_)

def genOberflaechenpunkt(m_punkt,rad):
    evec = ['1.0','0.0','0.0'] # Einheitsvektor in x-Richtung
    o_punkt = []
    for i in range(3):
        erg = float(m_punkt[i]) + float(rad) * float(evec[i])
        zahl = _descartesFloat2StrFormat_ % erg
        o_punkt.append( zahl )
    return o_punkt

def getRadius(m_punkt,o_punkt):
    if leer(m_punkt) or leer(o_punkt):
        print "Punktangabe fehlt . . .",
        return None
    else:
        rvec = genRichtVec(o_punkt,m_punkt)
        rad = betrag(rvec)
    return rad



def punktAufGerade(k,a_punkt,rvec):
    """bestimmt den Punkt P fuer den Parameter k
    in x = a_punkt + k * rvec
    ACHTUNG: d_punkt hat float-Koordinaten!!!
    OUT: d_punkt (type float)"""
    d_punkt = []
    for i in range(3):
        erg = float(a_punkt[i]) + float(k) * float(rvec[i])
        d_punkt.append( erg )
    #print GGT(d_punkt[0],d_punkt[1],d_punkt[2])
    return d_punkt

def bestimmeKreisPunkte(m_punkt,rad,nvec):
    """Bestimme vier Punkte auf Kreislinie
    IN: Mittelpunkt m_punkt, Radius rad, Normalenvektor nvec
    OUT: cPunktLi (Liste der vier Punkte)"""
    cPunktLi = []
    rvecA = rvec1(nvec)
    rvecB = rvec2(nvec)
    #print rvecA, rvecB,nvec
    if (betrag(rvecA) != 0):
        rad_rvecA1 = skalarMult(rad * (1/betrag(rvecA)),rvecA)
        rad_rvecA2 = skalarMult(rad * (-1/betrag(rvecA)),rvecA)
    else:
        rad_rvecA1 = rvecA
        rad_rvecA2 = rvecA
    cPunkt1 = vecAdd(m_punkt,rad_rvecA1)
    cPunkt2 = vecAdd(m_punkt,rad_rvecA2)
    if (betrag(rvecB) != 0):
        rad_rvecB1 = skalarMult(rad * (1/betrag(rvecB)),rvecB)
        rad_rvecB2 = skalarMult(rad * (-1/betrag(rvecB)),rvecB)
    else:
        rad_rvecB1 = rvecB
        rad_rvecB2 = rvecB
    
    cPunkt3 = vecAdd(m_punkt,rad_rvecB1)
    cPunkt4 = vecAdd(m_punkt,rad_rvecB2)         

    _cP1 = vec2str(cPunkt1)
    _cP2 = vec2str(cPunkt2)
    _cP3 = vec2str(cPunkt3)
    _cP4 = vec2str(cPunkt4)

    cPunktLi.append( _cP1 )
    cPunktLi.append( _cP2 )
    cPunktLi.append( _cP3 )
    cPunktLi.append( _cP4 )
    return cPunktLi
    
    

def schnittKE(m_punkt,rad,nvec,_d_):    
    """Schnitt: Kugel K, Ebene E"""
    if nullVektorTest(nvec):
        print "Keine Ebenengleichung!",
        return None
    elif leer(m_punkt) :
        print "Punktangabe fehlt . . .",
        return None    
    
    distanz = abstandEP(nvec,_d_,m_punkt)
    if (float(distanz) < float(rad) ): # Schnittebene
        #print "Schnittkreis"
        ergebnis = schnittGE(m_punkt,nvec,nvec,_d_)
        fusspunkt = ergebnis[1]
        radF = float(rad)
        distanzF = float(distanz)
        schnittRadius = math.sqrt( radF * radF - distanzF * distanzF) # pythagoras: r^2 = sr^2 + d^2 => sr^2 = r^2 - d^2
        # Bestimme Punkte auf Kreislinie
        cPunktLi = bestimmeKreisPunkte(fusspunkt,schnittRadius,nvec)        
        return [fusspunkt,schnittRadius,cPunktLi]
    elif ( _nullTest_( (float(distanz) - float(rad)) ) ):
        loesVec = schnittKG(m_punkt,rad,m_punkt,nvec)
        for punkt in loesVec:
            if punktProbeE(nvec,_d_,punkt):
                #print "Tangentialebene"
                return [punkt]
    else:
        #print "Schnittmenge leer . . ."
        return []
    

def schnittKG(m_punkt,rad,a_punkt,rvec):    
    """Schnitt: Kugel K, Gerade g"""
    loesVec = []
    if nullVektorTest(rvec):
        print "Keine Geradengleichung!",
        return None
    elif leer(a_punkt) or leer(m_punkt):
        print "Punktangabe fehlt . . .",
        return None    
    distanz = abstandGP(a_punkt,rvec,m_punkt)
    #print distanz, rad
    diff = float(distanz) - float(rad)
    #print diff
    if (float(distanz) <= float(rad) ): # Tangente oder Sekante        
        numPart = genRichtVec(m_punkt,a_punkt)
        #print numPart
        abcVec = generateABCvec(numPart,rvec,rad)
        #print abcVec
        loesung = abcFormel(abcVec[0],abcVec[1],abcVec[2])
        #print loesung
        if len(loesung) > 0:
            for element in loesung:
                punkt = punktAufGerade(element, a_punkt, rvec)
                _Vec_ = vec2str(punkt)
                loesVec.append( _Vec_ )                
    return loesVec
    

def schnittKK(m_punkt1,rad1,m_punkt2,rad2):    
    """Schnitt: Kugel K1, Kugel K2"""
    _debug_ = 0
    mp1_test = mp2_test = []
    loesVec = []
    if leer(m_punkt1) or leer(m_punkt2):
        print "Punktangabe fehlt . . .",
        return None
    # Abstand der beiden Kugeln    
    nvec = genRichtVec(m_punkt1,m_punkt2)
    distanz = betrag(nvec)

    summe = (float(rad1) + float(rad2))
    diff = abs((float(rad1) - float(rad2)) )
    if _debug_:
        print summe, diff, distanz
    

    nvec2 = skalarMult(2,nvec) # 2*nvec
    _d_ = vektorQuadrat(m_punkt1) - vektorQuadrat(m_punkt2) - float(rad1)**2 + float(rad2)**2

    ergLi = schnittKE(m_punkt2,rad2,nvec2,(-1)*_d_)   # Beachte: schnittKE gibt auch 4 Punkte auf der Kreislinie zurueck!
    if ergLi:
        if len(ergLi) == 3: # Schnittkreis
            if _debug_:
                print "Die Kugeln schneiden sich"            
            return ergLi
        
        elif len(ergLi) == 1: # "Beruehrpunkt B"
            if _debug_:
                print "Die Kugeln beruehren sich: Beruehrpunkt B"
            return ergLi
        
        else: # Schnittmenge leer
            if _debug_:
                print "Schnittmenge leer"
            return []
    else: #
        if _debug_:
            print ">>> Schnittmenge leer <<<"
    
        mp2_test = abstandKP(m_punkt1,rad1,m_punkt2)
        mp1_test = abstandKP(m_punkt2,rad2,m_punkt1)
        if (mp1_test[0] < 0) and (rad2 > abs(float(mp1_test[1]))) and (rad2 > rad1) and (float(distanz) < rad2):
            if _debug_:
                print "Mittelpunkt von Kugel 1 in Kugel 2"
                print mp1_test
                print "Schnittmenge leer"
            return []
        elif (mp2_test[0] < 0) and (rad1 > abs(float(mp2_test[1]))) and (rad1 > rad2) and (float(distanz) < rad1):
            if _debug_:
                print "Mittelpunkt von Kugel 2 in Kugel 1"
                print mp2_test
                print "Schnittmenge leer"
            return []                            
        elif (float(distanz) > summe ): # Kugeln beruehren sich nicht
            if _debug_:
                print "Schnittmenge leer"
            return []
        elif (nullTest(distanz) and not (nullTest(diff)) ): # gleicher Mittelpunkt; unterschiedlicher Radius
            if _debug_:
                print "Gleicher Mittelpunkt, unterschiedlicher Radius"
            return []
        elif (nullTest(distanz) and (nullTest(diff)) ): # gleicher Mittelpunkt; gleicher Radius => Kugeln identisch!
            if _debug_:
                print "Kugeln identisch"
            return [m_punkt1,rad1]              
            

def generateABCvec(numPart,rvec,rad):
    #print numPart,rvec,rad
    epsilon=1.0e-5
    retVec = []
    a = 0
    b = 0
    c = 0
    for i in range(3):
        a = a + float(rvec[i]) * float(rvec[i])
        b = b + 2*float(rvec[i]) * float(numPart[i])
        c = c + float(numPart[i]) * float(numPart[i])
    if nullTest(a, eps = epsilon):
        retVec.append(0.0)
    else:
        retVec.append(a)
    if nullTest(b, eps = epsilon):
        retVec.append(0.0)
    else:
        retVec.append(b)
        

    c = c - ( float(rad) * float(rad) )
    if nullTest(c, eps = epsilon):
        retVec.append(0.0)
    else:
        retVec.append(c)
        
    retVec = vec2float( vec2str( retVec ) )
    
    return retVec


###################################################################
############## interne Methoden => Argumente vom Typ <float> !!!

def _vecAdd_(uvec,vvec):
    ret = []
    for i in range(len(uvec)):        
        ret.append( uvec[i] + vvec[i] )
    return ret
    
    

    
def _rad2deg_(x):
    """radiant => degree """
    return ( (x*180.0) / math.pi )


def _betrag_(vec):
    """liefert Betrag/Laenge des Vektors"""
    ret = 0
    for i in range(len(vec)):
        ret = ret + vec[i]**2  # float(vec[i]) * float(vec[i])
    return math.sqrt(ret)


def _skalarMult_(k,vec):
    """liefert k*vec"""
    rvec = []
    for i in range(len(vec)):
        rvec.append( vec[i]*k  ) 
    return rvec

def _skalarProdukt_(uvec,vvec):
    """liefert Skalarprodukt von uvec * vvec"""
    ret = 0
    for i in range(len(uvec)):        
        ret = ret + uvec[i] * vvec[i]
    return ret


def _winkel_(uvec,vvec,sinus=0):
    """liefert Winkel zwischen uvec und vvec"""
    sp = _skalarProdukt_(uvec,vvec)
    nenner =  (_betrag_(uvec) * _betrag_(vvec) )
    if nenner != 0:
        sp = sp / nenner
    else:
        return None
    if sp >= -1.0  and  sp <= 1.0:
        if sinus:
            alpha = abs(_rad2deg_(math.asin(sp) ) )
        else:
            alpha = abs(_rad2deg_(math.acos(sp) ) )
        if alpha > 90:
            alpha = 180 - alpha
        return alpha
    else:
        return None


def _solveLin_(a,u):
    """ Gleichung: a = x * u, Lösung: x = a/u
        a,u: type float
        ACHTUNG: gibt ein Tupel zurueck, ergebnis an zweiter Stelle!
    """
    if _nullTest_( u ):
        if _nullTest_( a ):
            return ("unend",0)
        else:  # a != 0, u = 0 => undefiniert: a/0  !!
            return ("leer",None)
    else: # u != '0'
        return ("ein", a/u )     



def _linearAbhaengig_(uvec,vvec):
    """Test auf lineare Abhängigkeit zweier Vektoren"""
    solution = []
    result = None
    x = None
    for i in range(len(uvec)):
        erg = _solveLin_(float(uvec[i]) , float(vvec[i]) )        
        if erg[0] == "leer":
            return 0
        elif erg[0] == "ein": #
            solution.append(erg[1])
            x = erg[1]
        else: # Lösung mehrdeutig
            solution.append("z")
    #print solution,x
    if x:
        for i in range(len(solution)): 
            if solution[i] == "z":                
                solution[i] = x
    #print solution
    try:
        result = _nullTest_(solution[0]-solution[1]) and _nullTest_(solution[0]-solution[2]) and _nullTest_(solution[1]-solution[2])
        return result
    except:
        return 1

def _streicheZeile_(ma,i):
    del ma[i:i+1]


def _streicheSpalte_(ma,j):
    (z, s) = (len(ma), len(ma[0]))
    for i in range(z):
        del ma[i][j:j+1]    
            


def _det_(matrix):
    """Bestimmt Determinante einer 2x2 Matrix"""
    return matrix[0][0]*matrix[1][1] - matrix[0][1]*matrix[1][0]


def _abcFormel_(a,b,c):
    """loest quadratische Gleichung, gibt Liste zurueck"""
    p = b/a
    q = c/a
    D = p*p/4 - q
    #print p,q,D
    if (D >= 0):
        r = math.sqrt(D)
        if _nullTest_(r):
            x = ((-1) * p/2)
            return [x]
        else:
            pHalb = ((-1) * p/2)
            x1 = pHalb + r
            x2 = pHalb - r
            return [x1,x2]
    else:
        return []


def _sucheNullSpalte_(m):
    eps = 1.0/(10**10)
    pivot = None
    tauschen = 0
    (zeilen,spalten) = (len(m), len(m[0]))
    if zeilen <> spalten:
        print "nichtquadratisch . . ."
    nullz = 0
    pivotListe = []
    for i in range(0,spalten):
        nullzaehler = 0
        for j in range(0,zeilen):
           if abs(m[j][i]) <= eps:
               nullzaehler = nullzaehler + 1
        if nullzaehler == zeilen:
            nullz = nullz + 1
            print "Tauschen!"
            tauschen = 1
            pivotListe.append(0)
        else:
            pivotListe.append(1)
    if nullz == spalten:
        print "Nullmatrix"
        print pivotListe
        return (m,pivot)
    else:
        if tauschen:
            # Matrix neu aufbauen
            print pivotListe
            mat = []
            for i in range(0,zeilen):
                zeile = []
                for j in range(0,spalten):                
                    if pivotListe[j] <> 0:
                        zeile.append(m[i][j])
                    else:
                        pivot = j
                if len(zeile) > 0:
                    mat.append(zeile)
            print "Neue Matrix (sucheNullSpalte): "
            print mat
            return (mat,pivot)
        else:
            return (m,pivot)
                
        
def _gauss_jordan_(m, eps = 1.0/(10**10)):
  """Puts given matrix (2D array) into the Reduced Row Echelon Form.
     Returns True if successful, False if 'm' is singular.
     NOTE: make sure all the matrix items support fractions!
     !!! Int matrix will NOT work !!!
     Written by Jarno Elonen in April 2005, released into Public Domain
     URL: http://elonen.iki.fi/code/misc-notes/python-gaussj/index.html
  """
  (h, w) = (len(m), len(m[0]))
  for y in range(0,h):
    maxrow = y
    for y2 in range(y+1, h):    # Find max pivot
      if abs(m[y2][y]) > abs(m[maxrow][y]):
        maxrow = y2
    (m[y], m[maxrow]) = (m[maxrow], m[y])
    if abs(m[y][y]) <= eps:     # Singular?
      return False
    for y2 in range(y+1, h):    # Eliminate column y
      c = m[y2][y] / m[y][y]
      for x in range(y, w):
        m[y2][x] -= m[y][x] * c
  for y in range(h-1, 0-1, -1): # Backsubstitute
    c  = m[y][y]
    for y2 in range(0,y):
      for x in range(w-1, y-1, -1):
        m[y2][x] -=  m[y][x] * m[y2][y] / c
    m[y][y] /= c
    for x in range(h, w):       # Normalize row y
      m[y][x] /= c
  return True



###################################################################
#################### 0000000000  null 0000000000
def nullTest(zahl,eps=1.0e-7):
    return _nullTest_( float(zahl), _eps_ = eps )

    
def _nullTest_(zahl,_eps_=1.0e-7):
    #epsilon = 1.0/(10**7)  = 0.0000001
    #epsilon = 1.0/(10**10) 
    epsilon = _eps_
    if abs(zahl) < epsilon:
        return 1
    else:
        return 0

def nullVektorTest(vec):
    if leer(vec):        
        return None # 1 ==> Nullvektor
    else:
        erg = nullTest(vec[0]) and nullTest(vec[1]) and nullTest(vec[2])        
        return erg

def leer(vec):
    """falls als Vektor [] uebergeben wurde"""
    if len(vec) < 1:        
        return 1 # Liste vec == []
    else:
        return 0
    
###################################################################
###################################################################    
# wird (noch?) nicht benutzt!!!

def det3(ma):
    """Bestimmt (muehsam) Determinante einer 3x3 Matrix"""
    unter = []
    for i in range(3):
        mj = []
        for j in range(1,3):
            mj.append(ma[i][j])
        unter.append(mj)
        
    unterMat = []
    for i in range(3):        
        unterMat.append(unter[:])
        _streicheZeile_(unterMat[i],i)
    #print unterMat                
    erg = ma[0][0] * _det_(unterMat[0])
    erg = erg - ma[1][0] * _det_(unterMat[1])       
    erg = erg + ma[2][0] * _det_(unterMat[2])         
    return erg


def toMatrix2(apunkt,bpunkt,vec1,vec2):
    mat = []
    zeile = []
    for i in range(len(vec1)):
        zeile = []
        zeile.append(float(vec1[i]))
        zeile.append(float(vec2[i]))
        zeile.append(float(bpunkt[i]) - float(apunkt[i]) )
        mat.append(zeile)    
    return mat

def vecToMatrix(vec1,vec2,vec3=None):
    mat = []
    for i in range(len(vec1)):
        zeile = []
        if vec3:
            zeile.append( float(vec1[i]) )
            zeile.append( float(vec2[i]) )
            zeile.append( float(vec3[i]) )            
        else:
            zeile.append( float(vec1[i]) )
            zeile.append( float(vec2[i]) )            
        mat.append(zeile)
    #print mat
    return mat                  




