# -*- coding: utf-8 -*-
# File: miniEditor.py
# Editior-Komponente, Vers. 0.17
# WS, 2015-03-07
###################################################################
__version__ = "0.17"
pgdate = "2015-03-07"

###################################################################
standAlone = 0
import os,sys,string
home_dir = os.getcwd() + os.sep
sys.path.append( home_dir )
if standAlone:
    module_pfad = os.getcwd() + os.sep + "minimod" + os.sep 
    sys.path.append( module_pfad )

from Tkinter import *
from ScrolledText import *
import tkFileDialog
import tkMessageBox
from MultiStatusBar import MultiStatusBar
import codecs
import ToolTip # from IDLE
import cPickle
import fileList
###


if standAlone:
    icon_pfad = home_dir + "icons" + os.sep 
    sys.path.append( icon_pfad )

## font and font-size
me_font_art='normal'
me_font_type='courier'
if os.name == 'posix':
    me_font_size=12
else:    
    ##me_font_type='systemfixed'    
    me_font_size=10
me_font=(me_font_type,me_font_size,me_font_art)


## für DirListe
prevUsed=fileList.DirList()
dbList_dici = {}
dbListFile = 'editorEntries.ini'
###############################
def init_dbDici(max):
    """Datenstruktur dbList_dici initialisieren"""        
    global dbList_dici
    for i in range(max):
        dbList_dici[i] = ''
    
    
def dbList_speichern():
    """DB-Liste speichern in der Datei settings.get('dblist_file')"""        
    global dbList_dici
    laenge = prevUsed.listLength()    
    init_dbDici(prevUsed.DirMax)   ## wichtig!!
    for i in range(laenge):
        dbList_dici[i] = prevUsed.DirListe[i]
        ##alternativ:
        ##dbList_dici.update({i:prevUsed.DirListe[i]})        
    try:
        #print
        #print home_dir + dbListFile
        dbList_datei = open(home_dir + dbListFile ,'wb')
        cPickle.dump(dbList_dici,dbList_datei)
        dbList_datei.close()
    except:
        tkMessageBox.showerror('FeHlEr!', 'Speichern der ini-Datei fehlgeschlagen!' )             

def dbDici2prevUsed(max):
    """Wandelt das dbUsed_Dicitionary in eine prevUsed-Liste"""            
    tempUsed=fileList.DirList()
    tempListe = []
    for i in range(max):
        tempListe.append(dbList_dici.get(i))
    tempListe.reverse()
    for element in tempListe:
        if element <> '':
           tempUsed.addEntry(element)
    return tempUsed       

def dbList_holen(max,dbList_file=''):
    """Liest die DB-Liste aus der Datei settings.get('dblist_file')"""        
    global dbList_dici, prevUsed    
    try:
        if dbList_file<>'':
            dbList_datei = open(dbList_file,'rb')
        else:    
            dbList_datei = open(home_dir + dbListFile,'rb')
            dbList_dici = cPickle.load(dbList_datei)
        dbList_datei.close()
        prevUsed = dbDici2prevUsed(max)
    except:     ## Probleme beim Lesen, die dblist_file wird neu initialisiert
        init_dbDici(max)
        dbList_datei = open(home_dir + dbListFile,'wb')
        cPickle.dump(dbList_dici,dbList_datei)
        dbList_datei.close()
        prevUsed = dbDici2prevUsed(max)        
        ##tkMessageBox.showerror('FeHlEr!', 'Lesen der ini-Datei fehlgeschlagen!' )             



def kopiereDici(fromDici,toDici):
    """tiefe Kopie eines Dicis"""
    maxDici = len(fromDici)
    if maxDici > 0:
        toDici.clear()
        bereich = fromDici.iterkeys()
        for j in bereich:
            toDici[j] = fromDici[j]

################################
class Dialog(Toplevel): 
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm
    # Modifikation 1: der Cancel-Button kann ausgeblendet werden => _cancelButton_ = 1
    def __init__(self, parent, title = None,_cancelButton_ = 1): 
 
        Toplevel.__init__(self, parent) 
        self.transient(parent) 
 
        if title: 
            self.title(title) 
 
        self.parent = parent 
        
        self.result = False
        
        if (_cancelButton_ == 1):
            self.cancelButton = 1
        else:
            self.cancelButton = 0
 
        body = Frame(self) 
        self.initial_focus = self.body(body) 
        body.pack(padx=5, pady=5) 
 
        self.buttonbox() 
 
        self.grab_set() 
 
        if not self.initial_focus: 
            self.initial_focus = self 
 
        self.protocol("WM_DELETE_WINDOW", self.cancel) 
 
        self.geometry("+%d+%d" % (parent.winfo_rootx()+150, 
                                  parent.winfo_rooty()+100)) 
 
        self.initial_focus.focus_set() 
 
        self.wait_window(self)

        
 
    # 
    # construction hooks 
 
    def body(self, master): 
        # create dialog body.  return widget that should have 
        # initial focus.  this method should be overridden 
 
        pass 
 
    def buttonbox(self): 
        # add standard button box. override if you don't want the 
        # standard buttons 
         
        box = Frame(self) 
 
        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE) 
        w.pack(side=LEFT, padx=5, pady=5)
        if self.cancelButton:
            w2 = Button(box, text="Cancel", width=10, command=self.cancel) 
            w2.pack(side=LEFT, padx=5, pady=5) 
 
        self.bind("<Return>", self.ok)
        
        if self.cancelButton:        
            self.bind("<Escape>", self.cancel) 
 
        box.pack() 
 
    # 
    # standard button semantics 
 
    def ok(self, event=None): 
 
        if not self.validate(): 
            self.initial_focus.focus_set() # put focus back 
            return 
 
        self.withdraw() 
        self.update_idletasks()

        self.result = True
 
        self.apply() 
         
        self.cancel() 
 
    def cancel(self, event=None): 
 
        # put focus back to the parent window
        
        self.parent.focus_set() 
        self.destroy() 
 
    # 
    # command hooks 
 
    def validate(self): 
 
        return 1 # override 
 
    def apply(self): 
 
        pass # override 
#######################################
class myMsgBox(Dialog):
    # wird benutzt im Suchen-Dialog
    def __init__(self,parent,_title_ = None,_label_= None): 
	 self.value = False
	 self.labelText = None
	 
         if len(_label_) > 0:             
             self.labelText = _label_
         else:
             self.labelText = "WS-MsgBox"	            
         
         Dialog.__init__(self,parent,_title_) 
         
    def body(self, master):  
        self.label1 = Label(master, text=self.labelText)
        self.label1.grid(row=0, column=0) 
                   
        self.resizable('0','0')  # window should not be resizable!        
        
        return self.label1 # initial focus
   
    def apply(self): 
        self.value = self.result    
#######################################
class searchEingabe(Dialog):
    # wird benutzt im Suchen-Dialog
    def __init__(self,parent,_title_ = None,_label_= None,_searchOptions_ = {}): 
	 self.value = None
	 self.labelText = None
	 
         self.regex = False
         self.dirfb = False
         self.word = False
         self.case = False
         self.wrap = True
         
##         self.ret_regex = IntVar()
##         self.ret_dirfb = IntVar()
##         self.ret_word = IntVar()
##         self.ret_case = IntVar()
##         self.ret_wrap = IntVar()

         self.ret_regex = None
         self.ret_dirfb = None
         self.ret_word = None
         self.ret_case = None
         self.ret_wrap = None
 
         if len(_label_) > 0:             
             self.labelText = _label_
         else:
             self.labelText = "Suche Text: "
	 

         
         self.searchOptions = {}
         kopiereDici(_searchOptions_,self.searchOptions)
         
##      "old_search":self.oldSearchText
	 self.searchExpr = self.searchOptions["old_search"]
  
         self.variable = StringVar(parent)
         self.searchResult = StringVar(parent)
         
         Dialog.__init__(self,parent,_title_) 
         
    def body(self, master):  
        self.label1 = Label(master, text=self.labelText)
        self.label1.grid(row=0, column=0) 
        self.e1 = Entry(master,width=40)   
        self.e1.grid(row=0, column=1, columnspan=3)
        self.e1.insert(END,self.searchExpr)

        zeilen_zaehler = 1
        
        self.ret_case = BooleanVar(master)
        self.ret_case.set(self.case)
        Checkbutton(master,variable=self.ret_case).grid(row=zeilen_zaehler, column=0, sticky=E)
        self.label_case = Label(master, text="GROß/kleinschreibung")
        self.label_case.grid(row=zeilen_zaehler, column=1, sticky=E)


        self.ret_regex = BooleanVar(master)
        self.ret_regex.set(self.regex)
        Checkbutton(master,variable=self.ret_regex).grid(row=zeilen_zaehler, column=2, sticky=W)
        self.label_regex = Label(master, text="regulärer Ausdruck")
        self.label_regex.grid(row=zeilen_zaehler, column=3, sticky=E)

        zeilen_zaehler = 2

        self.ret_dirfb = BooleanVar(master)
        self.ret_dirfb.set(self.dirfb)
        self.label_dirfb = Label(master, text="Richtung:")
        self.label_dirfb.grid(row=zeilen_zaehler, column=0, sticky=W)
        
        Radiobutton(master,text="vorwärts",value=False,variable=self.ret_dirfb).grid(row=zeilen_zaehler, column=1, sticky=W)
        Radiobutton(master,text="rückwärts",value=True,variable=self.ret_dirfb).grid(row=zeilen_zaehler, column=3, sticky=W)
                   
        self.resizable('0','0')  # window should not be resizable!
        
        
        return self.e1 # initial focus
   
    def apply(self):
        # 
        self.searchResult = self.e1.get()
                
        # searchOptions = {"dir":'0',"wrap":'0',"whole_word":'0',"match_case":'0',"reg_exp":'0'}
        self.searchOptions['reg_exp'] = self.ret_regex.get()        
        self.searchOptions['dir'] = self.ret_dirfb.get()
        #self.searchOptions['whole_word'] = self.ret_word.get()
        self.searchOptions['match_case'] = self.ret_case.get()
        #self.searchOptions['wrap'] = self.ret_wrap.get()        
        

##############################
class replaceEingabe(Dialog):
    # wird benutzt im Suchen-Dialog
    def __init__(self,parent,_title_ = None,_label_= None,_searchOptions_ = {}): 
	self.value = None
	self.labelText = None
	 
        self.regex = False
        self.dirfb = False
        self.word = False
        self.case = False
        self.wrap = True
         
        self.repAll = False
         
##         self.ret_regex = IntVar()
##         self.ret_dirfb = IntVar()
##         self.ret_word = IntVar()
##         self.ret_case = IntVar()
##         self.ret_wrap = IntVar()

        self.ret_regex = None
        self.ret_dirfb = None
        self.ret_word = None
        self.ret_case = None
        self.ret_wrap = None
        self.ret_repAll = None
 
        if len(_label_) > 0:             
            self.labelText = _label_
        else:
            self.labelText = "Suche Text: "

        
        self.replaceLabel = "Ersetze durch: "

         
        self.searchOptions = {}
        kopiereDici(_searchOptions_,self.searchOptions)
        ##      "old_search":self.oldSearchText,"old_replace":self.oldReplaceText   
	self.searchExpr = self.searchOptions["old_search"]
	self.replaceExpr = self.searchOptions["old_replace"]
	
        self.variable = StringVar(parent)
        self.searchResult = StringVar(parent)
        self.replaceResult = StringVar(parent)

        self._repAll_value_ = BooleanVar(parent)
        self._repAll_value_.set(False)        
         
        Dialog.__init__(self,parent,_title_) 
         
    def body(self, master):  
        self.label1 = Label(master, text=self.labelText)
        self.label1.grid(row=0, column=0, sticky=W) 
        self.e1 = Entry(master,width=40)   
        self.e1.grid(row=0, column=1, columnspan=3)
        self.e1.insert(END,self.searchExpr)


        self.label2 = Label(master, text=self.replaceLabel)
        self.label2.grid(row=1, column=0, sticky=W) 
        self.e2 = Entry(master,width=40)   
        self.e2.grid(row=1, column=1, columnspan=3)
        self.e2.insert(END,self.replaceExpr)


        zeilen_zaehler = 2
        
        self.ret_case = BooleanVar(master)
        self.ret_case.set(self.case)
        Checkbutton(master,variable=self.ret_case).grid(row=zeilen_zaehler, column=0, sticky=E)
        self.label_case = Label(master, text="GROß/kleinschreibung")
        self.label_case.grid(row=zeilen_zaehler, column=1, sticky=E)


        self.ret_regex = BooleanVar(master)
        self.ret_regex.set(self.regex)
        Checkbutton(master,variable=self.ret_regex).grid(row=zeilen_zaehler, column=2, sticky=W)
        self.label_regex = Label(master, text="regulärer Ausdruck")
        self.label_regex.grid(row=zeilen_zaehler, column=3, sticky=E)

        zeilen_zaehler = 3

        self.ret_dirfb = BooleanVar(master)
        self.ret_dirfb.set(self.dirfb)
        self.label_dirfb = Label(master, text="Richtung:")
        self.label_dirfb.grid(row=zeilen_zaehler, column=0, sticky=W)
        
        Radiobutton(master,text="vorwärts",value=False,variable=self.ret_dirfb).grid(row=zeilen_zaehler, column=1, sticky=W)
        Radiobutton(master,text="rückwärts",value=True,variable=self.ret_dirfb).grid(row=zeilen_zaehler, column=3, sticky=W)



        zeilen_zaehler = 4

        self.ret_repAll = BooleanVar(master)
        self.ret_repAll.set(self.repAll)
        self.label_repAll = Label(master, text="Ersetze:")
        self.label_repAll.grid(row=zeilen_zaehler, column=0, sticky=W)
        
        Radiobutton(master,text="einfach ersetzen",value=False,variable=self.ret_repAll).grid(row=zeilen_zaehler, column=1, sticky=W)
        Radiobutton(master,text="ALLE ersetzen",value=True,variable=self.ret_repAll).grid(row=zeilen_zaehler, column=3, sticky=W)


                   
        self.resizable('0','0')  # window should not be resizable!
        
        
        return self.e1 # initial focus
   
    def apply(self):
        # 
        self.searchResult = self.e1.get()
        self.replaceResult = self.e2.get()
        self._repAll_value_ = self.ret_repAll.get()
        # searchOptions = {"dir":'0',"wrap":'0',"whole_word":'0',"match_case":'0',"reg_exp":'0'}
        self.searchOptions['reg_exp'] = self.ret_regex.get()        
        self.searchOptions['dir'] = self.ret_dirfb.get()
        self.searchOptions['match_case'] = self.ret_case.get()

        

##############################

class Editor(Toplevel):

    def __init__(self, parent, title = None, button_message = None,TEXT=None, x_dim = None, y_dim = None, state=None, loadfile=None, resize=None, pfad = None, module = None, MAIN = None  ):             
        
        #Toplevel.__init__(self, parent)
        ## Mit dem folgenden Befehl liegt das Fenster
        ## immer ueber dem parent-Fenster
        ##self.transient(parent)

        if MAIN: # standAlone = 1
            self.icon_pfad = icon_pfad
            self.standAlone = 1
        else:
            self.icon_pfad = os.getcwd() + os.sep + module + os.sep + "icons" + os.sep
            self.standAlone = 0
            #print self.icon_pfad
            #print pfad

            
        
        if os.name == 'posix':
            self.print_command = "lpr -p %s"
	else:
            self.print_command = "start /min notepad /p %s"


        self.parent = parent
        self.fenster = Toplevel(self.parent)
        self.fenster.withdraw()
        if title:
            self.fenster.title(title)

	if not resize:
	    self.fenster.resizable('0','0')  # window should not be resizable!

	# Suchen/Ersetzen
	self.oldSearchText = ""
        self.oldReplaceText = ""
        
        self.Text = TEXT

        self._body_ = Frame(self.fenster)        

        self.bar = Menu(self.fenster)

        if MAIN: # standAlone = 1
            self.dbUsedMenu = Menu(self.bar,tearoff=0)    
            laenge = prevUsed.listLength()
            for i in range(laenge):
                argument =  prevUsed.DirListe[i]
                self.dbUsedMenu.add_command(label=argument, command=(lambda arg=argument : self.dbUsed(arg) ) )
        
   
        self.filem = Menu(self.bar)   

        self.filem.add_command(label="Datei laden", command=self.laden)
        self.filem.add_command(label="Datei speichern",command=self.speichern)            
        self.filem.add_separator()
        
        if MAIN: # standAlone = 1
            self.filem.add_cascade(label="History", menu=self.dbUsedMenu) 
            self.filem.add_separator()

        self.filem.add_command(label="Speichern als",command=self.speichern_als)
        self.filem.add_separator()
        
        self.filem.add_command(label="Drucke Fenster",command=self.printFile)
        self.filem.add_separator()        
        
        self.filem.add_command(label="Beenden", command=self.die)
        

        self.searchm = Menu(self.bar)   
        self.searchm.add_command(label="Suchen", command=self.searchText)
        self.searchm.add_separator()
        self.searchm.add_command(label="Ersetzen", command=self.replaceText)
        self.searchm.add_separator()



##        self.aboutm = Menu(self.bar)   
##        self.aboutm.add_command(label="\xdcber", command=self.about)
##        self.aboutm.add_separator()
        
        #self.fenster.config(menu=self.bar)
        
        self.bar.add_cascade(label="Datei", menu=self.filem)
        self.bar.add_cascade(label="Bearbeiten", menu=self.searchm)
        
##        self.bar.add_cascade(label="\xdcber", menu=self.aboutm)
        
        
        self.fenster.config(menu=self.bar)
        



        self.upper_menu = Menu(self._body_,tearoff=0) 
         
        self.upper_menu.add_command(label='cut', command=(lambda arg='self.t' : self.me_cut(arg) )  )      
        self.upper_menu.add_command(label='copy', command=(lambda arg='self.t' : self.me_copy(arg) )  ) 
        #self.upper_menu.add_command(label='paste', command=(lambda arg='self.t' : self.me_paste(arg) )  )
        self.upper_menu.add_command(label='paste', command=self.me_paste_no_arg )
        self.upper_menu.add_separator() 
        self.upper_menu.add_command(label='Linux-Filter', command=(lambda arg='1' : self.linux_filter(arg) ) ) 
        
        

        # size of window
        if not x_dim:   
            self.width = 80
        else:    
            self.width = x_dim
            
        if not y_dim:
            self.height = 28
        else:    
            self.height = y_dim
            
        if state:
            self.state = state
        else:
            self.state = NORMAL
            
        if pfad:
            self.lastdir = pfad
        else:
            self.lastdir = os.getcwd()  
            self.lastdir = os.path.abspath (os.getcwd()) + os.sep
        
            
        self.loadfile = loadfile            
        #self.t = None # Textfenster
        
        if not button_message:        
            self.close_message = "Quit"   
        else:
            self.close_message = button_message
        
        if MAIN:
            self.mainENDE = 1
        else:
            self.mainENDE = None
        
        self.buttonbox()
        
        self.body()
        
            
        #self.buttonbox()
        
        ## Der folgende Befehl verhindert, dass der
        ## Focus auf ein anderes Fenster gesetzt werden kann 
        ##self.grab_set()

        self.fenster.protocol("WM_DELETE_WINDOW", self.die)

        self.fenster.geometry("+%d+%d" % (parent.winfo_rootx()+50, parent.winfo_rooty()+50))        

        #self.fenster.lift()
        self.fenster.update()     # neu
        
        self.fenster.deiconify()  # Unhide pyMaxima
        
        self.fenster.focus_set()


        
        
        

        

    #
    # construction hooks
    def popup(self, event): 
        self.upper_menu.post(event.x_root, event.y_root) 

    def body(self):
        # create dialog body. 

        self.t = ScrolledText(self._body_,width=self.width,height=self.height,relief=RAISED,font=me_font,bd=2,background="white",foreground="black",wrap=WORD)
        self.t.config(state=NORMAL)  # see http://effbot.org/zone/tkinter-text.htm
        if self.Text:
            self.t.insert(END,self.Text)
        if self.loadfile:    
            self.openFile()
        self.t.pack(fill=BOTH, expand=1)  ## important
        self.t.config(state = self.state)
        self.t.bind("<Button-3>",self.popup)
        if os.name == 'posix':
            self.t.bind('Control_C',self.me_copy_)
            self.t.bind('Control_c',self.me_copy_)
                    
            self.t.bind('Control_X',self.me_cut_)
            self.t.bind('Control_x',self.me_cut_)
            
            self.t.bind('Control_V',self.me_paste_)
            self.t.bind('Control_v',self.me_paste_)
        else:  # win nt
            self.t.bind('Control_C',self.me_copy_)                    
            self.t.bind('Control_X',self.me_cut_)            
            self.t.bind('Control_V',self.me_paste_)

        self.set_status_bar()
        
        self._body_.pack(fill=BOTH, expand=1)

    

    def buttonbox(self):
        # add standard button box. override if you don't want the
        # standard buttons
        
        box = Frame(self.fenster)
        
        self.openpic = self.savepic = self.closepic = self.aboutpic = None

        try:
            self.openpic = PhotoImage(file=self.icon_pfad+'open.gif')
            self.savepic = PhotoImage(file=self.icon_pfad+'save.gif')
            self.closepic = PhotoImage(file=self.icon_pfad+'exit.gif')
            self.aboutpic = PhotoImage(file=self.icon_pfad+'about.gif')            
        except:
            pass
        
        if self.openpic:
            w = Button(box, text= "Open",image=self.openpic,bd="1",  command=self.laden)
            self.tip_openpic = ToolTip.ToolTip(w, "\n Datei öffnen \n")
        else:
            w = Button(box, text= "Open",  command=self.laden)
            self.tip_openpic = ToolTip.ToolTip(w, "\n Datei öffnen \n")
            
        w.pack(side=LEFT, fill=BOTH, expand=1)
        
        if self.savepic:
            #w2 = Button(box, text= "Save",image=self.savepic,bd="1", command=self.speichern)
            w4 = Button(box, text= "Save as",image=self.savepic,bd="1", command=self.speichern_als)
            self.tip_savepic = ToolTip.ToolTip(w4, "\n Datei speichern als \n")
        else:
            #w2 = Button(box, text= "Save", command=self.speichern)
            w4 = Button(box, text= "Save as", command=self.speichern_als)
            self.tip_savepic = ToolTip.ToolTip(w4, "\n Datei speichern als \n")
            
        #w2.pack(side=LEFT,fill=BOTH,  expand=1)
        w4.pack(side=LEFT,fill=BOTH,  expand=1)

        if self.aboutpic:
            w5 = Button(box, text= "About",image=self.aboutpic,bd="1", command=self.about)
            self.tip_aboutpic = ToolTip.ToolTip(w5, "\n Über . . . \n")
        else:
            w5 = Button(box, text= "About", command=self.about)
            self.tip_aboutpic = ToolTip.ToolTip(w5, "\n Über . . . \n")

        w5.pack(side=LEFT, fill=BOTH, expand=1)                


        if self.closepic:
            w3 = Button(box, text= self.close_message,image=self.closepic,bd="1", command=self.close)
            self.tip_closepic = ToolTip.ToolTip(w3, "\n Beenden \n")
        else:
            w3 = Button(box, text= self.close_message, command=self.close)
            self.tip_closepic = ToolTip.ToolTip(w3, "\n Beenden \n")

        w3.pack(side=LEFT, fill=BOTH, expand=1)

        #self.bind("<Return>", self.ok)

        box.pack( fill=BOTH, expand=0)

        
    def set_status_bar(self):
        # from IDLE, see http://www.python.org/idle
        # Copyright (c) 2001-2006 Python Software Foundation.
        self.status_bar = MultiStatusBar( self._body_ )
        self.status_bar.set_label('column', 'Spalte: ?', side=RIGHT)
        self.status_bar.set_label('line', 'Zeile: ?', side=RIGHT)
        self.status_bar.pack(side=BOTTOM, fill=X)
        self.t.bind('<KeyRelease>', self.set_line_and_column)
        self.t.bind('<ButtonRelease>', self.set_line_and_column)
        self.t.after_idle(self.set_line_and_column)


    def set_line_and_column(self, event=None):
        # from IDLE, see http://www.python.org/idle
        # Copyright (c) 2001-2006 Python Software Foundation.
        line, column = string.split(self.t.index(INSERT), '.')
        self.status_bar.set_label('column', 'Spalte: %s' % column)
        self.status_bar.set_label('line', 'Zeile: %s' % line)




    def dbUsed(self, arg=None):
        """Verwaltet den Zugriff auf die Liste der letzten 15 benutzten Sitzungsdateien"""
        global prevUsed
        from os.path import abspath, exists
        debug = 0
        if debug:
            print arg
        if os.path.exists(arg):
            prevUsed.swapFirst(arg)
            self.update_dbUsedMenu()                
            self.laden_zwei(_loadfile_=arg)
        else: # Datei zu Eintrag existiert nicht => Eintrag loeschen
            prevUsed.delEntry(arg)
            self.update_dbUsedMenu()
            #print "problem"

        
    def update_dbUsedMenu(self): 
        """ !!Funktioniert!! EXPERIMENTELL!!"""
        self.dbUsedMenu.delete(0,END)
        laenge = prevUsed.listLength()
        for i in range(laenge):
            argument =  prevUsed.DirListe[i]
            self.dbUsedMenu.add_command(label=argument, command=(lambda arg=argument:self.dbUsed(arg) ))

    #
    # standard button semantics
    def set_cursor(self): 
        """Call: set_cursor() => set the cursor to the  end of the session in the window """
        win = self.t
        win.mark_set("insert", "end-1c")
        win.see(INSERT)
        
        #win.yview(END) 
        #win.update_idletasks()
        
    def printFile( self ):
        # Druckt Fensterinhalt mithile temp. Datei
        ergebnis = 0
        _text_ = self.t.get(1.0, END)
        if len(_text_) > 0:
            ergebnis = tkMessageBox.askokcancel("Drucke Fenster . . .", "Fensterinhalt drucken?")
            if ergebnis:
                if os.name == 'posix':
                    filename = '/tmp/minied.%s.txt' % os.getpid()
                else:
                    filename = 'c:' + os.sep + 'temp'  + os.sep +  'minied%s.txt' % os.getpid()
                #print filename
                try:
                    _temp_ = open(filename, 'w+b')
                    _temp_.write( _text_ )
                    if os.name == 'posix':
                        _temp_.close()
                    cmd = self.print_command % filename
                    #print cmd
                    os.system( cmd )                               
                finally:
                    _temp_.close()
                    if os.name == 'posix':
                        # Clean up the temporary file yourself
                        os.remove(filename)                
            

        
        

    def holeDateiName(self):        
        sname = tkFileDialog.asksaveasfilename(filetypes=[('Encapsulated PostScript', "*.eps"),('Alle Dateien',"*")],initialdir=pfad) 
        if sname:
            if not test_extension(sname,".eps"):
                sname = sname + ".eps"
        return sname

        


#######################################
##      mark, copy and paste
##      with widget.clipboard_append/
##      clipboard_clear/selection_get(selection="CLIPBOARD")
##      see: von Lï¿œis/Fischbeck: Python 2, S. 339-341
##	or M. Lutz: Programming Python, S. 382-385            
##      Beachte: diese Form von Mark, Copy & Paste ist VERALTET!
##      Vgl. die Programmierung von IDLE bzw. die Funktion  "me_paste_no_arg"   
    def me_copy(self,fenster):
        win = self.t
        try:
            marked_text = win.get(SEL_FIRST, SEL_LAST)
            win.clipboard_clear()
            win.clipboard_append(marked_text)
        except TclError:
            pass


    def me_paste_no_arg(self):                   
        win = self.t
        #win.delete("1.0",END)
        win.event_generate("<<Paste>>")
        # Event-List: https://www.tcl.tk/man/tcl/TkCmd/event.htm#M60
    
    def me_paste(self,fenster): 
        win = self.t
        try:
            text = win.selection_get(selection="CLIPBOARD")
            win.insert(INSERT, text)
        except TclError:
            pass
                    
    def me_cut(self,fenster):
        win = self.t
        try:
            marked_text = win.get(SEL_FIRST, SEL_LAST)
            win.delete(SEL_FIRST, SEL_LAST)
            win.clipboard_clear()
            win.clipboard_append(marked_text)
        except TclError:
            pass

    def me_copy_(self,event):
	self.me_copy('Fenster')

    def me_cut_(self,event):
	self.me_cut('Fenster')

    def me_paste_(self,event):
	self.me_paste('')

    def close(self, event=None):

        if not self.validate():
            self.initial_focus.focus_set() # put focus back
            return

        self.fenster.withdraw()
        self.fenster.update_idletasks()

        #self.apply()
        self.parent.lift()
        
        self.die()


    def searchText(self):
        _debug_ = False

        searchOptions = {"dir":False,"wrap":True,"whole_word":False,"match_case":False,"reg_exp":False,"old_search":self.oldSearchText}
        # dir (forw/backw): radiobutton
        # wrap around, whole word, match case, regular expression: check buttons
        if _debug_:
            print "dir vor Dialog:", searchOptions['dir']
            print
            
        
        
        eingabe = searchEingabe(self.fenster,"Suche","Suche Text: ",searchOptions)
        searchExpr =  string.strip(str(eingabe.searchResult))
        if _debug_:
            #print searchExpr
            print "dir nach Dialog:", str(eingabe.searchOptions['dir'])
            #print "wrap nach Dialog:", str(eingabe.searchOptions['wrap'])
            #print "word nach Dialog:", str(eingabe.searchOptions['whole_word'])
            print "case nach Dialog:", str(eingabe.searchOptions['match_case'])
            print "reg_exp nach Dialog:", str(eingabe.searchOptions['reg_exp'])
            print

        _back_ = None
        _exact_ = True # default
        _regExp_ = None
        _nocase_ = None
                
        if eingabe.searchOptions['dir']: # funktioniert!
            _back_ = True
        
        if eingabe.searchOptions['reg_exp']:  # funktioniert (hoffentlich)! 
            _regExp_ = True
            _exact_ = False

        if not eingabe.searchOptions['match_case']: # funktioniert!
            _nocase_ = True
            
        
        if len(searchExpr) > 0:
            
            self.oldSearchText = searchExpr

            if _back_:
                start = END
            else:
                start = 1.0
            while 1:
                
                if _back_:                    
                    pos = self.t.search(searchExpr, start, stopindex=1.0, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )
                else:
                    pos = self.t.search(searchExpr, start, stopindex=END, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )

                        
                if not pos:
                    break            
                self.t.see(pos)
                if _debug_:
                    print pos
                self.t.tag_add("markYellow",pos,self.add2index(pos,len(searchExpr) ) )
                self.t.tag_config("markYellow", background="yellow", foreground="red")
                posListe = string.split(pos,".")
                
                self.fenster.lower()
                self.parent.lower()
                
                _msg_ = '<' + searchExpr + '> gefunden in Zeile: ' + posListe[0] + ', Spalte: ' + posListe[1]
                weiter = myMsgBox(self.fenster,'Ergebnis', _msg_ )
                
                if _debug_:
                    print weiter.value
                
                #weiter = tkMessageBox.askokcancel('SeArCh . . .', '<' + searchExpr + '> gefunden in Zeile: ' + posListe[0] + ', Spalte: ' + posListe[1] )
                
                self.fenster.lift()
                self.fenster.focus_set()
                
                if not weiter.value:
                    self.t.tag_remove("markYellow",pos,self.add2index(pos,len(searchExpr) ) )
                    break
                self.t.tag_remove("markYellow",pos,self.add2index(pos,len(searchExpr) ) )
                if _back_:
                    start = pos + "-1c"
                else:
                    start = pos + "+1c"
        
    def add2index(self,pos,zahl):
        # neuer_index = alter_index + len(STRING)
        posListe = string.split(pos,".")
        neu = int(posListe[1]) + zahl
        pos = posListe[0] + "." + str(neu)
        #print pos
        return pos


    def replaceText(self):
        _debug_ = False

        searchOptions = {"dir":False,"wrap":True,"whole_word":False,"match_case":False,"reg_exp":False,"old_search":self.oldSearchText,"old_replace":self.oldReplaceText}
        # dir (forw/backw): radiobutton
        # wrap around, whole word, match case, regular expression: check buttons
        if _debug_:
            print "dir vor Dialog:", searchOptions['dir']
            print

        repEingabe = replaceEingabe(self.fenster,"Ersetze","Suche Text: ",searchOptions)
        
        searchExpr =  string.strip(str(repEingabe.searchResult))
        replaceExpr =  string.strip(str(repEingabe.replaceResult))
        
        if _debug_:
            print replaceExpr
            #print searchExpr
            print "dir nach Dialog:", str(repEingabe.searchOptions['dir'])
            print "case nach Dialog:", str(repEingabe.searchOptions['match_case'])
            print "reg_exp nach Dialog:", str(repEingabe.searchOptions['reg_exp'])
            print

        _back_ = None
        _exact_ = True # default
        _regExp_ = None
        _nocase_ = None
        _repAlle_ = False
                
        if repEingabe.searchOptions['dir']: # funktioniert!
            _back_ = True
        
        if repEingabe.searchOptions['reg_exp']:  # funktioniert (hoffentlich)! 
            _regExp_ = True
            _exact_ = False

        if not repEingabe.searchOptions['match_case']: # funktioniert!
            _nocase_ = True

        if repEingabe._repAll_value_:
            _repAlle_ = True
            
        if _debug_:
            print _repAlle_
        
        if (len(searchExpr) > 0) and (len(replaceExpr) > 0):
            
            self.oldSearchText = searchExpr
            
            self.oldReplaceText = replaceExpr
            
            if _back_:
                start = END
            else:
                start = 1.0

            if _repAlle_:  # alle ersetzen                    
                if _back_:                    
                    pos = self.t.search(searchExpr, start, stopindex=1.0, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )
                else:
                    pos = self.t.search(searchExpr, start, stopindex=END, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )
                        
                if pos:                   
                    self.t.see(pos)
                    if _debug_:
                        print pos
                        
                    self.fenster.lower()
                    self.parent.lower()                

                    
                    _msg_ = 'Ersetze ALLE <' + searchExpr + '> durch <' + replaceExpr + '>'
                    weiter = myMsgBox(self.fenster,'Ersetze ALLE', _msg_ )
                    #weiter = tkMessageBox.askokcancel('Replace ALL', 'Ersetze ALLE <' + searchExpr + '> durch <' + replaceExpr + '>' )

                    self.fenster.lift()
                    self.fenster.focus_set()
                    
                    if weiter.value: # Code zum ersetzen:
                        #print "Ersetze . . . "
                        text = self.t.get(pos, END)
                        text = string.replace(text,searchExpr,replaceExpr)                        
                        self.t.delete(pos, END)
                        self.t.insert(pos, text)                        
                        
            else:
                if _back_:                    
                    pos = self.t.search(searchExpr, start, stopindex=1.0, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )
                else:
                    pos = self.t.search(searchExpr, start, stopindex=END, backwards=_back_, exact=_exact_, regexp = _regExp_, nocase=_nocase_ )

                        
                if pos:
                    self.t.see(pos)
                    if _debug_:
                        print pos
                    
                    self.t.tag_add("markYellow",pos,self.add2index(pos,len(searchExpr) ) )
                    self.t.tag_config("markYellow", background="yellow", foreground="red")
                    
                    self.fenster.lower()
                    self.parent.lower()
                    
                    _msg_ = 'Ersetze <' + searchExpr + '> durch <' + replaceExpr + '>'
                    weiter = myMsgBox(self.fenster,'Ersetze', _msg_ )
                    
                    #weiter = tkMessageBox.askokcancel('RePlAcE . . .', 'Ersetze <' + searchExpr + '> durch <' + replaceExpr + '>' )
                    
                    self.fenster.lift()
                    self.fenster.focus_set()
                    
                    self.t.tag_remove("markYellow",pos,self.add2index(pos,len(searchExpr) ) )
                    
                    if weiter.value: # Code zum ersetzen:
                        #print "Ersetze . . . "
                        text = self.t.get(pos, END)
                        text = string.replace(text,searchExpr,replaceExpr,1)                        
                        self.t.delete(pos, END)
                        self.t.insert(pos, text)                        
                    



        

    def formatieren(self):
        schrifttyp=self.schrifttyp.get()                  
        self.t.config(font=(schrifttyp,10))

    def openFile(self):
        OK = 0
        self.t.delete(1.0, END)                        
        if self.loadfile:
            try:
                self.linux_filter(dateiLaden=0,datei=self.loadfile)
            except:
                pass
            self.datei = codecs.open(self.loadfile, "r", "utf-8")            
            try:
                data = self.datei.read()
                self.t.insert(1.0, data)
                self.datei.close()
                OK = 1
            except:
                self.datei.close()
            if not OK:
                self.datei = open(self.loadfile, "r")
                try:
                    data = self.datei.read()
                    self.t.insert(1.0, data)
                    self.datei.close()
                    OK = 1
                except:
                    self.datei.close()
                    print "Mist"                                   
    
    def laden (self):
        self.fenster.iconify()        
        self.loadfile = tkFileDialog.askopenfilename(filetypes=[('Text-Dateien', "*.txt"),('HTML-Dateien', "*.html"),('Python-Dateien', "*.py"),('Alle Dateien',"*")],initialdir=self.lastdir)
        self.fenster.deiconify()
        self.fenster.lift()
        self.parent.lower()
        self.lastdir = os.path.abspath(os.path.dirname(self.loadfile)) + os.sep         
        if self.loadfile:
            newTitle = "Datei: " + self.loadfile
            self.fenster.title(newTitle)
            self.openFile()
            if self.standAlone: # standAlone = 1
                prevUsed.addEntry(self.loadfile)
                prevUsed.swapFirst(self.loadfile)
                self.update_dbUsedMenu()
            
            self.fenster.focus_set()


    def laden_zwei (self, _loadfile_):
        self.loadfile = _loadfile_
        self.lastdir = os.path.abspath(os.path.dirname(self.loadfile)) + os.sep         
        if self.loadfile:
            newTitle = "Datei: " + self.loadfile
            self.fenster.title(newTitle)
            self.openFile()
            self.fenster.focus_set()




    def speichern (self,dateiname=None):
        OK = 0
        if dateiname <> None:
            self.loadfile = dateiname
            #print self.loadfile
        if self.loadfile:
            _data_ = ucodefilter_( self.t.get(1.0, END), 0 )  # wichtig wg. der Umlaute!
            
            try:
                self.datei = codecs.open(self.loadfile,"w", "utf-8")
                self.datei.write( _data_ )   
                self.datei.close()
                OK = 1
            except:
                self.datei.close()
            if not OK:
                try:
                    self.datei = open(self.loadfile,"w")
                    self.datei.write( _data_ )  
                    self.datei.close()
                    OK = 1
                except:
                    self.datei.close()
                    print "Mist"


    def speichern_als (self):
        self.fenster.iconify()                
        self.dateiname = tkFileDialog.asksaveasfilename(filetypes=[('Text-Dateien', "*.txt"),('HTML-Dateien', "*.html"),('Python-Dateien', "*.py"),('Alle Dateien',"*")],initialdir=self.lastdir)
        self.fenster.deiconify()
        self.fenster.lift()
        self.parent.lower()
        if self.dateiname:
            _ext_ = os.path.splitext(self.dateiname)  # Extension holen
            if len(_ext_[1]) < 1:   # Ist eine Extension da?
                if not test_extension(self.dateiname,".txt"):
                    self.dateiname = self.dateiname + ".txt"                    
            self.speichern(dateiname=self.dateiname)
            # In Editor neue Datei laden
            newTitle = "Datei: " + self.dateiname
            self.fenster.title(newTitle)
            self.loadfile = self.dateiname
            #self.openFile()
            self.fenster.focus_set()



    def die(self, event=None):
        # put focus back to the parent window
        self.parent.focus_set()        
        if self.mainENDE <> None:
            ende()
        else:
            self.fenster.destroy()
        
    #
    # command hooks
##    def linux_filter(self,debug=0):
##        # aufrufen nach dem Kopieren!    
##        from os.path import splitext, exists
##
##        self.loadfile = tkFileDialog.askopenfilename(filetypes=[('Text-Dateien', "*.txt"),('Alle Dateien',"*")],initialdir=self.lastdir)
##
##        changed = 0
##        neu = []
##
##        for zeile in open(self.loadfile,"rb").readlines(): # Datei zeilenweise lesen
##            if zeile[-2:] == '\r\n':
##                zeile = zeile[:-2] + '\n'
##                changed = 1
##            neu.append(zeile)                
##        if changed:
##            try:
##                open(self.loadfile,'wb').writelines(neu)
##            except IOError:
##                feedback = 'Konvertieren bei der Datei ' + self.loadfile + ' lief schief . . .'
##                print feedback #ausgabe( feedback )
##

    def linux_filter(self,dateiLaden = 1, datei = None, debug=0):
        # aufrufen nach dem Kopieren!    
        from os.path import splitext, exists
        changed = 0
        neu = []
        if dateiLaden:
            self.loadfile = tkFileDialog.askopenfilename(filetypes=[('Text-Dateien', "*.txt"),('HTML-Dateien', "*.html"),('Python-Dateien', "*.py"),('Alle Dateien',"*")],initialdir=self.lastdir)
        else:        
            self.loadfile = datei
        if self.loadfile:    
            for zeile in open(self.loadfile,"rb").readlines():
                if zeile[-2:] == '\r\n':
                    zeile = zeile[:-2] + '\n'
                    changed = 1
                neu.append(zeile)
            if changed:
                try:
                    open(self.loadfile,'wb').writelines(neu)
                except IOError:
                    feedback = 'Konvertieren bei der Datei ' + self.loadfile + ' lief schief . . .'
                    print feedback #ausgabe( feedback )

    def about(self):
        self.fenster.iconify()
        tkMessageBox.showinfo("Info",  
         "miniEditor by Walter Spiegel\n" +
         "Version " + __version__ + ", " + pgdate)
        self.fenster.deiconify()
        self.fenster.lift()
        self.parent.lower()
        

    def validate(self):

        return 1 # override

    def apply(self):

        pass # override



########################################

def ucodefilter_(zeile,dec=1,org=1,debug=0):
    "kodiert Unicode-Sonderzeichen in HTML"
    # die Sonderzeichen werden im Dictionary 'codes' festgelegt
    import umlautCodec
    if org:
        codes = umlautCodec.unicode2org
    else:
        codes = umlautCodec.unicodeCodes
    
    text = ''
    try:
        if dec:
            zeile = zeile.decode('iso-8859-1')            
            #print zeile
    except:
        pass
    try:
        zeile = zeile.encode('latin-1')
    except:
        pass
    for i in range( len(zeile) ):
        #if debug:
        #    print zeile[i]
        try:    
            if codes.has_key(zeile[i]):
                #print zeile[i]
                text = text + codes[zeile[i]]
            else:
                text = text + zeile[i]
        except:
            text = text + zeile[i]
            
        if debug:
            print text,    
    return text
    

def test_extension(Dateiname,Erweiterung):
    Dateiname = string.lower(Dateiname)
    if ( string.rfind(Dateiname,Erweiterung) == -1 ):
        return 0
    else:  ## Erweiterung in Dateiname gefunden
        return 1   

def ende():
   root.destroy()
   if standAlone:
       dbList_speichern()
   sys.exit(0)

def testen(pfad):
    _debug_ = 0
    myButton = "Beenden"    
    oname = tkFileDialog.askopenfilename(filetypes=[('Text-Dateien', "*.txt"),('HTML-Dateien', "*.html"),('Python-Dateien', "*.py"),('Alle Dateien',"*")],initialdir=pfad) 
    if _debug_:
        print oname
    if oname:
	lastdir = os.path.abspath(os.path.dirname(oname)) + os.sep
	if _debug_:
            print lastdir
        myTitle = "Datei: " + str(oname)
        
        prevUsed.addEntry(oname)
        prevUsed.swapFirst(oname)        

        Editor(root,title=myTitle, button_message=myButton, TEXT=None, resize=1,loadfile=oname,pfad=lastdir, MAIN=1 )    
    
    
########################################       
## main ##
if __name__ == '__main__':
    pfad = os.getcwd()  
    pfad = os.path.abspath (os.getcwd()) + os.sep
    sys.path.append( os.getcwd() )
    
    dbList_holen(prevUsed.DirMax)
    
    root = Tk()
    
    if os.name == 'posix': # in Linux: gtkLook!
        try:
            root.tk.eval('source {gtklook.tcl}')
            root.tk.eval('gtk_look')
        except:
            pass
    
    
    root.protocol('WM_DELETE_WINDOW',ende)
    root.withdraw()
    
    testen(pfad)   
    
    root.mainloop()






