# -*- coding: utf-8 -*-
"""
tkMatrix.py: Eingabe-Widgets für pyGeo-Objekte
ws

Vers. 0.10: 2008-03-31
- rat2float bzw. r2f integriert (erlaubt Bruchschreibweise) => Modul util.py

Vers. 0.11: 2008-04-02
- class ColorPicker, abgeleitet aus Dialog; integriert in Normalform, Ebene (Parameterebene), ePunkte (Ebene aus drei Punkten)
- class Dreieck

Vers. 0.12: 2008-04-04
- class ColorPicker integriert in Gerade, gPunkte (Gerade aus zwei Punkten), Punkte
- class VecPunkte

Vers. 0.13: 2008-04-27
- class Matrix => Eingabe des Matrix-Namens
- class zweiZeiler durch class dreiZeiler ersetzt => Eingabe des Matrix-Namens

Vers. 0.14: 2008-05-01
- class DimMNfensterName => holt Dimension + Name

Vers. 0.15: 2008-05-03
- class ColorPicker integriert in Dreieck (fuer Kreis!)

Vers. 0.16: 2008-05-04
- class ColorPicker integriert in kugel, rKugel
- neue Klasse Kugel4P, abgeleitet von der Klasse ColorPicker (fuer Kugel durch 4 Punkte)

Vers. 0.17: 2008-05-22
- class ColorPicker integriert in Pyramide, tPunkte

Vers. 0.18: 2012-02-26
- class pyramide fuer den Quader angepasst (abgeleitet aus der Klasse ColorPicker)

Vers. 0.19: 2012-02-26
- class Koordinatenform => Fenster fuer Ebene in Koordinatenform (abgeleitet aus der Klasse ColorPicker)

Vers. 0.20: : 2012-03-04
- Bug in Klasse ColorPicker beseitigt => die Vereinbarúng self.colVariable = StringVar() findet sich nur noch im Konstruktor "__init__",
  NICHT nochmals in colBox(self)!!

Vers. 0.21: : 2015-03-29
- class gPunkte(ColorPicker) wird jetzt auch für eine Strecke durch zwei Punkte verwendet (bedingt KEINE Aenderungen im Programmcode!
    
"""
#############################################
import os
import Tkinter
if os.name == 'posix':
    Tkinter.wantobjects = 0
    # tkMessageBox.askyesno wrong result under Linux!
    # see http://mail.python.org/pipermail/python-bugs-list/2004-September/025172.html

from Tkinter import *  
import tkMessageBox 
from tkFileDialog import *
# try: help(tkFileDialog)

import string
import fileinput
import pymaxUtil as util


class Dialog(Toplevel): 
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm   
    def __init__(self, parent, title = None): 
 
        Toplevel.__init__(self, parent) 
        self.transient(parent) 
 
        if title: 
            self.title(title) 
 
        self.parent = parent 
 
        self.result = None


     
        body = Frame(self) 
        self.initial_focus = self.body(body) 
        body.pack(padx=5, pady=5) 

        self.colBox()
 
        self.buttonbox() 
 
        self.grab_set() 
 
        if not self.initial_focus: 
            self.initial_focus = self 
 
        self.protocol("WM_DELETE_WINDOW", self.cancel) 
 
        self.geometry("+%d+%d" % (parent.winfo_rootx()+50, 
                                  parent.winfo_rooty()+50)) 
 
        self.initial_focus.focus_set() 
 
        self.wait_window(self) 
 
    # 
    # construction hooks 
 
    def body(self, master): 
        # create dialog body.  return widget that should have 
        # initial focus.  this method should be overridden 
        pass

    def colBox(self):
        pass
 
    def buttonbox(self): 
        # add standard button box. override if you don't want the 
        # standard buttons 
         
        box = Frame(self) 
 
        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE) 
        w.pack(side=LEFT, padx=5, pady=5) 
        w = Button(box, text="Cancel", width=10, command=self.cancel) 
        w.pack(side=LEFT, padx=5, pady=5) 
 
        self.bind("<Return>", self.ok) 
        self.bind("<Escape>", self.cancel) 
 
        box.pack() 
 
    # 
    # standard button semantics 
 
    def ok(self, event=None): 
 
        if not self.validate(): 
            self.initial_focus.focus_set() # put focus back 
            return 
 
        self.withdraw() 
        self.update_idletasks() 
 
        self.apply() 
 
        self.cancel() 
 
    def cancel(self, event=None): 
 
        # put focus back to the parent window        
        self.parent.focus_set() 
        self.destroy() 
 
    # 
    # command hooks 
 
    def validate(self): 
 
        return 1 # override 
 
    def apply(self): 
 
        pass # override

#################################################################
class ColorPicker(Dialog):   
    # wird eingebaut in die Klassen dieses Moduls
    def __init__(self,parent,_title_ = None,_colList_ = [], _colorIndex_ = 0):
        self.color = "Default"
	self.value = None
        self.colList = _colList_[:]
        #print self.colList
        self.colorIndex = _colorIndex_
	# self.colVariable = StringVar(parent)
        # self.colVariable nur im Konstruktor "__init__" vereinbaren, NICHT nochmals in colBox(self)
        self.colVariable = StringVar()		
        
        Dialog.__init__(self,parent,_title_) 
         
    def colBox(self):  

        self.masterF = Frame(self)
        self.masterF.pack() #sticky=NSEW)#side=TOP, padx=5, pady=5)


        #self.label2 = Label(master, text="Color:")
        self.colLabel = Label(self.masterF, text="Farbe:")
        self.colLabel.grid(row=0, column=0) 
        self.colFrame = Frame(self.masterF)
        self.colFrame.grid(row=0, column=1, sticky=NSEW)#side=TOP, padx=5, pady=5)



        self.colE = Entry(self.colFrame,width=12)   
        self.colE.pack(side=LEFT, padx=2, pady=2,fill=X)
        # Farbe einstellen
        color = string.strip( self.colList[self.colorIndex] )
        if color == "Verylight":
            color = "White"
        if color == "Default":
            color = "Black"
            
        if color in ["Yellow", "Pink", "Lightgray", "Verylight" ,"White"]:
            self.colE.config( bg = "Darkgray" )
        else:
            self.colE.config( bg = "White" )
        self.colE.config( fg = color )
        
        self.colE.insert(END,self.colList[self.colorIndex])
       
        self.colVariable.set(self.colList[self.colorIndex]) # default value

        #print tuple(self.list)
        #self.varOpt = apply(OptionMenu, (listFrame, self.variable) + tuple(self.list)  )
        # URL: http://effbot.org/tkinterbook/optionmenu.htm
        self.varOpt = OptionMenu(self.colFrame, self.colVariable, *tuple(self.colList) )
        self.varOpt.pack(side=LEFT, padx=2, pady=2,fill=X)
        
        self.resizable('0','0')  # window should not be resizable!
        
        self.colVariable.trace('w',self.changed )
        
        return self.colE # initial focus
   
    def apply(self):           
        pass #self.color = string.strip( self.colE.get() ) 

    #
    # construction hooks
    def changed(self,*args):
        # URL: http://mail.python.org/pipermail/tutor/2005-July/040018.html
        #print self.variable.get()  # das geht tatsächlich . . .
        self.colE.delete( 0,END )
        # Farbe einstellen
        color = string.strip( self.colVariable.get() )
        if color == "Verylight":
            color = "White"
        if color == "Default":
            color = "Black"
            
        if color in ["Yellow", "Pink", "Lightgray", "Verylight" ,"White"]:
            self.colE.config( bg = "Darkgray" )
        else:
            self.colE.config( bg = "White" )
        self.colE.config( fg = color )
        self.colE.insert( END, self.colVariable.get() ) # das geht !!!



        

    
#################################
class Koeffizienten(Dialog):
    """Fenster für Erweiterte Koeffizientenmatrix: Lineare Gleichungssysteme"""     
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm   
    

    def __init__(self,parent,_title_ = None,dimension = None): 
         self.mtx = []
	 self.dim = dimension
         Dialog.__init__(self,parent,_title_) 


    
    def body(self, master):            

        
        self.default = False
            
        self.entries = {}
        
        self.title("Erweiterte Koeffizientenmatrix")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        # default = 0.0
        for i in range(0,self.dim):
            for j in range(0,self.dim):
                a_ij = "a"+str(i+1)+str(j+1)+ " "
                wert = '0'
                Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j + offset] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                self.entries[i*self.dim + j + offset].insert(END, str( wert ) )
                self.entries[i*self.dim + j + offset].grid(row=i, column=2*j+1)
            c_i = "c"+str(i+1)+ "  " # rechte Seite der erweiterten Koeffizientenmatrix
            wert = '0'
            Label(master, text=c_i,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*self.dim+1)            
            self.entries[i*self.dim + (self.dim-1) + offset + 1] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
            self.entries[i*self.dim + (self.dim-1) + offset + 1].insert(END, str( wert ) )
            self.entries[i*self.dim + (self.dim-1) + offset + 1].grid(row=i, column=2*self.dim+2)
            offset = offset + 1
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        offset = 0
        self.result = 1
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim):
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j + offset].get() ) ) 
                except:
                    self.result = None            
            try:    # einlesen der c_i = rechte Seite der erweiterten Koeffizientenmatrix 
                zeile.append(util.r2f( self.entries[i*self.dim + (self.dim-1) + offset + 1].get() ) ) 
                offset = offset + 1 
            except:
                self.result = None
            self.mtx.append(zeile)
        
#################################
class Matrix(Dialog):
    """Fenster für m x n - Matrix"""     
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm   
    

    def __init__(self,parent,_objectName_,_title_ = None,zeile = None, spalte = None): 
         self.mtx = []	 
	 self.zeile = int(zeile)
	 self.spalte = int(spalte)
	 self.diff = self.zeile - self.spalte
	 self.name = _objectName_
	 self._title_ = _title_
	 Dialog.__init__(self,parent,_title_) 


    
    def body(self, master):            

        
        self.default = False
            
        self.entries = {}
        
        self.title( self._title_ )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   

        self.upF = Frame(master) # fuer Matrix
        self.downF = Frame(master) # fuer Name
        self.upF.pack(fill=X,side=TOP)         
        self.downF.pack(fill=X,side=TOP) 

        # default = 0.0
        for i in range(0,self.zeile):
            for j in range(0,self.spalte):
                wert = '0'
                self.entries[i*(self.zeile - self.diff) + j ] = Entry(self.upF,width=10,font=(self.font_type,self.font_size,'normal') )
                self.entries[i*(self.zeile - self.diff) + j ].insert(END, str( wert ) )
                self.entries[i*(self.zeile - self.diff) + j ].grid(row=i, column=j)
                
        # Name der Matrix . . .      (row: Zeile)  (column:Spalte  
        Label(self.downF, text="Matrix-Name: ",width=12,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).pack(side=LEFT)
        self.entries[self.zeile*self.spalte+1] = Entry(self.downF,width=self.breite+3,font=(self.font_type,self.font_size,'normal') )
        self.entries[self.zeile*self.spalte+1].insert(END, self.name ) # Default-Name: self.name
        #self.entries[self.zeile*self.spalte+1].grid(row=self.zeile+1,column=1, sticky=E+W)
        self.entries[self.zeile*self.spalte+1].pack(side=LEFT)

        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   
                               
         
    def apply(self):

        self.result = 1
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        self.name = self.entries[self.zeile*self.spalte+1].get()        
        for i in range(0,self.zeile):
            zeile = []
            for j in range(0,self.spalte):
                try:
                    zeile.append(util.r2f( self.entries[i*(self.zeile - self.diff) + j ].get() ) ) 
                except:
                    self.result = None            
            self.mtx.append(zeile)
                

#################################
class Normalform(ColorPicker):   
    """Fenster für Ebene in Normalenform"""    

    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,nvec=None, _d_ = None, colorIndex=0):

        self.colList = _colList_[:]
        #print self.colList
	self.dim = 3
	self.name = geoObjectName
        if _d_:
            self.edit = 1
            self._d_ = str(_d_)
            self.mtx = nvec
        else:            
            self.mtx = []
            self.edit = 0
	self.dim = 3
	self.name = geoObjectName
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            

        
        self.default = False
            
        self.entries = {}
        
        self.title("Ebene in Normalenform")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 3
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 3
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        xvec = ['x1','x2','x3']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            if (i==1):
                a_ij = xvec[i] + ' * '
            else:
                a_ij = xvec[i] 
                        
            Label(master, text=a_ij,width=self.breite+2,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=0)

            self.entries[i] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
            if self.edit:
                self.entries[i].insert(END, self.mtx[i] )                
            else:
                self.entries[i].insert(END, str( wert ) )
            self.entries[i].grid(row=i, column=1)
            
        Label(master, text=" - ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=1, column=2)

        self.entries[self.dim] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
        if self.edit:
            self.entries[self.dim].insert(END, self._d_ )            
        else:
            self.entries[self.dim].insert(END, str( wert ) )
        self.entries[self.dim].grid(row=1, column=3)
        Label(master, text=" = 0 ",width=self.breite+3,justify=LEFT,font=myFont,anchor=W).grid(row=1, column=4)
        # Name der Ebene . . .        
        Label(master, text="Name ",width=self.breite+2,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[4] = Entry(master,width=self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[4].insert(END, self.name ) # Default-Name: self.name
        self.entries[4].grid(row=3,column=1, columnspan=4,sticky=E+W)
        
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        self.name = self.entries[4].get()         
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim+1):
            zeile = []
            try:
                zeile.append(util.r2f( self.entries[i].get() ) )
                #print str(i*self.dim + j)
            except:
                self.result = None            
            self.mtx.append(zeile)
        
                
#################################
class Koordinatenform(ColorPicker):   
    """Fenster für Ebene in Koordinatenform"""    

    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,nvec=None, _d_ = None, colorIndex=0):

        self.colList = _colList_[:]
        #print self.colList
	self.dim = 3
	self.name = geoObjectName
        if _d_:
            self.edit = 1
            self._d_ = str(_d_)
            self.mtx = nvec
        else:            
            self.mtx = []
            self.edit = 0
	self.dim = 3
	self.name = geoObjectName
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            

        
        self.default = False
            
        self.entries = {}
        
        self.title("Ebene in Koordinatenform")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 3
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 3
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        xvec = ['x1','x2','x3']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Koordinaten
            wert = '0'
            if i < 2:
                a_ij = ' * ' + xvec[i] + ' + '
            else:
                a_ij = ' * ' + xvec[i]  

            self.entries[i] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
            # row = Zeile, column = Spalte            

            if self.edit:
                self.entries[i].insert(END, self.mtx[i] )                
            else:
                self.entries[i].insert(END, str( wert ) )
            self.entries[i].grid(row=0, column=2*i)

            Label(master, text=a_ij,width=self.breite+3,justify=LEFT,font=myFont,anchor=E).grid(row=0, column=2*i+1)

            
        Label(master, text=" = ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=0, column=7)

        self.entries[self.dim] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
        if self.edit:
            self.entries[self.dim].insert(END, self._d_ )            
        else:
            self.entries[self.dim].insert(END, str( wert ) )
        self.entries[self.dim].grid(row=0, column=8)
        
        # Label(master, text=" = 0 ",width=self.breite+3,justify=LEFT,font=myFont,anchor=W).grid(row=1, column=4)

        # Name der Ebene . . .        
        Label(master, text="Name           ",width=self.breite+10,justify=LEFT,font=myFont,anchor=E).grid(row=2, column=0,sticky=E+W)
        self.entries[4] = Entry(master,width=self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[4].insert(END, self.name ) # Default-Name: self.name
        self.entries[4].grid(row=2,column=1, columnspan=4,sticky=E+W)
        
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        self.name = self.entries[4].get()         
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim+1):
            zeile = []
            try:
                zeile.append(util.r2f( self.entries[i].get() ) )
                #print str(i*self.dim + j)
            except:
                self.result = None            
            self.mtx.append(zeile)
        
 

#############################################################        
class Ebene(ColorPicker):   
    """Fenster für Parameterebene"""        

    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,_parameter_ = None, colorIndex=0):
        self.colList = _colList_[:]        
	self.dim = 3
	self.name = geoObjectName
	if _parameter_:
            self.mtx = []
            self.edit = 1
            #print str(_parameter_)
            for j in range(0,self.dim):            
                for i in range(0,self.dim):
                    #print str(_parameter_[j][i])
                    self.mtx.append( str(_parameter_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            
        
        self.default = False
            
        self.entries = {}
        
        self.title("Ebene in Parameterform")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 7
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 5
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        # neue Reihenfolge: spaltenweise
        # Focus der Entries: in der Reihenfolge der Erzeugung!
        # siehe http://infohost.nmt.edu/tcc/help/pubs/tkinter/focus.html
        # The order in which the tab key traverses the widgets is:
        # For widgets that are children of the same parent, focus goes in the same order the widgets were created.
        # To sum up: to set up the focus traversal order of your widgets, create them in that order.
        # Remove widgets from the traversal order by setting their takefocus options to 0,
        # and for those whose default takefocus option is 0, set it to 1 if you want to add them to the order.
        
        # i: row = Zeile, j: column = Spalte
        for j in range(0,self.dim):  
            for i in range(0,self.dim):
                x_i = "x"+str(i+1)+ " = " # linke Seite: vec x
                Label(master, text=x_i,width=self.breite-2,justify=LEFT,font=myFont,anchor=W).grid(row=i, column= 0)
                ##### jetzt rechte Seite: Stuetzvektor und Spannvektoren
                wert = '0'            
                
                if (j == 1):
                    a_ij = " + r * "
                elif (j == 2):
                    a_ij = " + s * "
                else:
                    a_ij = ""
                wert = '0'
                if (j > 0): # wichtig: nur in der 2. und 3. Spalte wird etwas ausgegeben
                    if (i == 1): # und nur in der mittlere Zeile wird etwas ausgegeben
                        Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
                    else:                    
                        Label(master, text="         ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[j*self.dim + i] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                
                self.entries[i*self.dim + j].grid(row=i, column=2*j+2)
                
        # Name der Ebene . . .        
        Label(master, text="Name",width=self.breite,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[9] = Entry(master,width=self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[9].insert(END, self.name ) # Default-Name: self.name
        self.entries[9].grid(row=3,column=1, columnspan=6,sticky=E+W)
        
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   

##        alte Reihenfolge: zeilenweise
##        for i in range(0,self.dim):  
##            x_i = "x"+str(i+1)+ " = " # linke Seite: vec x
##            Label(master, text=x_i,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column= 0)
##            ##### jetzt rechte Seite: Stuetzvektor und Spannvektoren
##            wert = '0'            
##            for j in range(0,self.dim):
##                if (j == 1):
##                    a_ij = " + r *"
##                elif (j == 2):
##                    a_ij = " + s *"
##                else:
##                    a_ij = ""
##                wert = '0'
##                if (j > 0): # wichtig: nur in der 2. und 3. Spalte wird etwas ausgegeben
##                    if (i == 1): # und nur in der mittlere Zeile wird etwas ausgegeben
##                        Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
##                    else:                    
##                        Label(master, text="      ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
##                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
##                self.entries[i*self.dim + j].insert(END, str( wert ) )
##                self.entries[i*self.dim + j].grid(row=i, column=2*j+2)
##            
##        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        self.name = self.entries[9].get()         
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim):
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
        
                
 
#################################
class Dimfenster(Dialog):   

    def __init__(self,parent,_title_ = None):
        self._title_ = _title_
        Dialog.__init__(self,parent,_title_) 

    
    def body(self, master):      
        self.title( self._title_ )
        self.resizable('0','0')  # window should not be resizable!
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 13
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 13
            self.font_type = 'ansifixed'
        
        
        Label(master, text="Dimension n:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0)   
                
        self.e1 = Entry(master,width=28,font=(self.font_type,self.font_size,'normal') )   
        self.e1.insert(END, str(0) )         
        self.e1.grid(row=0, column=1)   

        return self.e1 # initial focus   
                               
         
    def apply(self):   
        self.a1 = self.e1.get() 
        self.result = 1
#################################
class DimMNfenster(Dialog):   
    # fuer n x m -Matrix
    def body(self, master):      
        self.title( "m x n -Matrix")
        self.resizable('0','0')  # window should not be resizable!
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 13
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 13
            self.font_type = 'ansifixed'
        
        
        Label(master, text="Zeilen  m:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=0)   
        Label(master, text="   ",width=3,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=1)   
        Label(master, text="Spalten n:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=2)   
                
        self.e1 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )   
        self.e1.insert(END, str(1) )         
        self.e1.grid(row=1, column=0)

        Label(master, text=" x ",width=3,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=1, column=1)   
        
        self.e2 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )   
        self.e2.insert(END, str(1) )         
        self.e2.grid(row=1, column=2)   

        return self.e1 # initial focus   
                               
         
    def apply(self):   
        self.a1 = self.e1.get()
        self.a2 = self.e2.get()         
        self.result = 1

#################################
class DimMNfensterName(Dialog):
    # fuer Null-Matrix (=> matZero in pyMaxima.py)
    def body(self, master):      
        self.title( "m x n -Matrix")
        self.resizable('0','0')  # window should not be resizable!
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 13
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 13
            self.font_type = 'ansifixed'
        
        
        Label(master, text="Zeilen  m:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=0)   
        Label(master, text="   ",width=3,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=1)   
        Label(master, text="Spalten n:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=2)   
                
        self.e1 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )           
        self.e1.insert(END, str(1) )         
        self.e1.grid(row=1, column=0)

        Label(master, text=" x ",width=3,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=1, column=1)   
        
        self.e2 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )           
        self.e2.insert(END, str(1) )         
        self.e2.grid(row=1, column=2)   

        Label(master, text="Matrix-Name:",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=2, column=0)   

        self.eName = Entry(master,width=16,font=(self.font_type,self.font_size,'normal') )           
        self.eName.insert(END, str("N1") )         
        self.eName.grid(row=2, column=1, columnspan = 2)   

        return self.e1 # initial focus

    def apply(self):   
        self.a1 = self.e1.get()
        self.a2 = self.e2.get()
        self.aName = self.eName.get()
        self.result = 1
        
#################################
class dreiZeiler(Dialog):
    # wird benutzt in matDiagonal bzw. in matEinheit (=> pyMaxima.py)
    def __init__(self,parent,_objectName_,_title_ = None, _labelA_ = None, _labelB_ = None):
        self._title_ = _title_
        self.labelA = _labelA_
        self.labelB = _labelB_
        if len(self.labelB) > 0: # Test auf Diagonalmatrix
            self.diagonal = 1
        else:
            self.diagonal = 0
        self.name = _objectName_
        self.defaultValue = str(1)
        Dialog.__init__(self,parent,_title_) 
    
    def body(self, master):      
        self.title( self._title_ )
        self.resizable('0','0')  # window should not be resizable!
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 19
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 19
            self.font_type = 'ansifixed'
        
        
        Label(master, text=self.labelA, width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=0, column=0)   
        self.e1 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )           
        self.e1.insert(END, self.defaultValue )         
        self.e1.grid(row=0, column=1)

        if self.diagonal:
            Label(master, text=self.labelB, width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=1, column=0)                               
            self.e2 = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )               
            self.e2.insert(END, self.defaultValue )              
            self.e2.grid(row=1, column=1)   

        # Name der Matrix . . .      (row: Zeile)  (column:Spalte  
        Label(master, text="Matrix-Name: ",width=self.breite,justify=LEFT,font=(self.font_type,self.font_size,'normal'),anchor=W).grid(row=2, column=0)
        self.eName = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )
        self.eName.insert(END, self.name ) # Default-Name: self.name
        #self.entries[self.zeile*self.spalte+1].grid(row=self.zeile+1,column=1, sticky=E+W)
        self.eName.grid(row=2, column=1) 

        return self.e1 # initial focus   
                               
         
    def apply(self):   
        self.a1 = self.e1.get()
        if self.diagonal:
            self.a2 = util.r2f( self.e2.get() )
        self.aName = self.eName.get()
        self.result = 1        
        
##################################################################################
class ePunkte(ColorPicker):      
    """Fenster für Ebene durch drei Punkte"""   
    def __init__(self,parent,geoObjectName,_colList_,_title_ = None,dimension = None,_punkte_ = None, colorIndex=0):
        
        self.colList = _colList_[:]
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['A','B','C']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim):
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name der Ebene . . .        
        Label(master, text="Name ",width=self.breite+2,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[9] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[9].insert(END, self.name ) # Default-Name: self.name
        self.entries[9].grid(row=3,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        self.name = self.entries[9].get() 
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim):
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
        
##################################################################################
class Dreieck(ColorPicker):      
    """Fenster für Dreieck/Kreis durch drei Punkte"""   
    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,_punkte_ = None, colorIndex=0):
        self.colList = _colList_[:]
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['A','B','C']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim):
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name des Dreiecks /des Kreises . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[9] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[9].insert(END, self.name ) # Default-Name: self.name
        self.entries[9].grid(row=3,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.name = self.entries[9].get()
        self.color = self.colE.get()
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!        
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim):
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
##################################################################################

####################################        
class pyramide(ColorPicker):      
    """Fenster für Pyramide: fuenf Punkte: A, B, C, D, S"""
    """sowie Fenster fuer Quader: fuenf Punkte: A, B, C, D, E"""   
    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,_punkte_ = None, colorIndex=0):
        
        self.colList = _colList_[:]
        
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim+2):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        # Test ob Pyramide oder Quader
        self.foundPyramide = string.find(_title_, "Py", 0,3)
        
        
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        if (self.foundPyramide == -1):
            points = ['A','B','C','D', 'E']
        else:
            points = ['A','B','C','D', 'S']
        # default = 0.0
        for i in range(0,self.dim + 2):  # 3 + 2 = 5 !!!
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim ):
                #print i, j, i*self.dim + j
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name der Pyramide . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=self.dim + 2, column=0)
        self.entries[15] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[15].insert(END, self.name ) # Default-Name: self.name
        self.entries[15].grid(row=self.dim + 2,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()
        self.name = self.entries[15].get() 
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim + 2):
            zeile = []
            for j in range(0,self.dim):
                #print i, j, i*self.dim + j
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None
            #print str(zeile)
            self.mtx.append(zeile)
        #print str(self.mtx)        
############################################################                

class tetraeder(Dialog):      
    """Fenster für Tetraeder; wird zur Zeit nicht genutzt; vgl. statt dessen tPunkte"""   
    def __init__(self,parent,geoObjectName,_title_ = None,dimension = None,_punkte_ = None):
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        
        Dialog.__init__(self,parent,_title_) 


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['A','B','C']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim):
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name der Ebene . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[9] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[9].insert(END, self.name ) # Default-Name: self.name
        self.entries[9].grid(row=3,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.name = self.entries[9].get() 
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim):
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
        
##################################################################################
class tPunkte(ColorPicker):      
    """Fenster für Tetraeder/Viereck: vier Punkte"""   
    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None,_punkte_ = None, colorIndex=0):
        self.colList = _colList_[:]
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim+1):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['A','B','C','D']
        # default = 0.0
        for i in range(0,self.dim + 1):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim ):
                #print i, j, i*self.dim + j
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name des Tetraeders . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=self.dim + 1, column=0)
        self.entries[12] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[12].insert(END, self.name ) # Default-Name: self.name
        self.entries[12].grid(row=self.dim + 1,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()        
        self.name = self.entries[12].get() 
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim + 1):
            zeile = []
            for j in range(0,self.dim):
                #print i, j, i*self.dim + j
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None
            #print str(zeile)
            self.mtx.append(zeile)
        #print str(self.mtx)
        

                


##################################################################################

class Gerade(ColorPicker):   
    """Fenster für Gerade in Punkt-Richtungsform"""        

    def __init__(self,parent,geoObjectName,_colList_,_title_ = None,dimension = None,_stuetzvec_=None,_richtvec_=None, colorIndex=0):
        self.colList = _colList_[:]
        self.dim = 3
        if _stuetzvec_:
            self.edit = 1
            self.mtx = []            
            for i in range(0,self.dim):
                for j in range(0,self.dim-1):  
                    if ((i*(self.dim-1) + j) % 2) == 0:
                        #print _stuetzvec_[i]
                        self.mtx.append( str(_stuetzvec_[i]) )
                    else:
                        #print _richtvec_[i]
                        self.mtx.append( str(_richtvec_[i]) )
            #print str(self.mtx)                    
        else:
            self.mtx = []
            self.edit = 0
            
	self.name = geoObjectName
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 



    
    def body(self, master):            
        
        self.default = False
            
        self.entries = {}
        
        self.title("Gerade in Punkt-Richtungsform")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 7
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 7
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        
        # i: row = Zeile, j: column = Spalte
        for j in range(0,self.dim-1):  
            for i in range(0,self.dim):
                x_i = "x"+str(i+1)+ " = " # linke Seite: vec x
                Label(master, text=x_i,width=self.breite-2,justify=LEFT,font=myFont,anchor=W).grid(row=i, column= 0)
                ##### jetzt rechte Seite: Stuetzvektor und Spannvektoren
                wert = '0'            
                
                if (j == 1):
                    a_ij = " + r * "
                else:
                    a_ij = ""
                wert = '0'
                if (j > 0): # wichtig: nur in der 2. und 3. Spalte wird etwas ausgegeben
                    if (i == 1): # und nur in der mittlere Zeile wird etwas ausgegeben
                        Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
                    else:                    
                        Label(master, text="       ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j+1)
                self.entries[i*(self.dim-1) + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:                    
                    self.entries[i*(self.dim-1) + j].insert(END, self.mtx[i*(self.dim-1) + j] )
                else:
                    self.entries[i*(self.dim-1) + j].insert(END, str( wert ) )
                self.entries[i*(self.dim-1) + j].grid(row=i, column=2*j+2)
        
        # Name der Gerade . . .        
        Label(master, text="Name",width=self.breite+1,justify=LEFT,font=myFont,anchor=W).grid(row=3, column=0)
        self.entries[6] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[6].insert(END, self.name ) # Default-Name: self.name
        self.entries[6].grid(row=3,column=1, columnspan=4,sticky=E+W)
        
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   


    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        #print str(self.dim)
        self.name = self.entries[6].get()         
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim-1):
                try:
                    zeile.append(util.r2f( self.entries[i*(self.dim-1) + j].get() ) )
                    #print self.entries[i*(self.dim-1) + j].get()
                    #print str(i*(self.dim-1) + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
##########################################################
            
class gPunkte(ColorPicker):   
    """Fenster für Gerade/Strecke durch zwei Punkte"""
    def __init__(self,parent,geoObjectName,_colList_,_title_ = None,dimension = None, _parameter_ = None, colorIndex=0):
        self.colList = _colList_[:]
        self.dim = 2
        self.name = geoObjectName
        #print "Parameter"
        #print _parameter_
        if _parameter_:

            self.edit = 1
            self.mtx = []
            for i in range(0,self.dim):
                for j in range(0,self.dim+1):
                    #print i,j
                    self.mtx.append( str(_parameter_[i][j]) )        
            #print str(self.mtx)                    
        else:
            self.mtx = []
            self.edit = 0


        self.fensterTitel = _title_
        
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
           
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        if (self.fensterTitel == "Tetraeder"):
            points = ['S','A']
        else:
            points = ['A','B']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim + 1):
                wert = '0'
                #print i,j
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*(self.dim + 1) + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:                    
                    self.entries[i*(self.dim + 1) + j].insert(END, self.mtx[i*(self.dim+1) + j] )
                else:
                    self.entries[i*(self.dim + 1) + j].insert(END, str( wert ) )
                                
                self.entries[i*(self.dim + 1) + j].grid(row=i, column=2*j+1)
        # Name der Gerade . . .        
        Label(master, text="Name",width=self.breite+1,justify=LEFT,font=myFont,anchor=W).grid(row=3, column=0)
        self.entries[6] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[6].insert(END, self.name ) # Default-Name: self.name
        self.entries[6].grid(row=3,column=1, columnspan=6,sticky=E+W)

            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #
        #print str(self.dim)
        self.name = self.entries[6].get()        
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim+1):
                try:
                    zeile.append(util.r2f( self.entries[i*(self.dim + 1) + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
##########################################################             
class Punkte(ColorPicker):   
    """Fenster für Eingabe eines Punktes"""        
    def __init__(self,parent,geoObjectName,_colList_,_title_ = None,dimension = None,_koeff_ = None, colorIndex=0):
        self.colList = _colList_[:]
        if _koeff_:
             self.mtx = _koeff_
             self.edit = 1
        else:
             self.mtx = []
             self.edit = 0
        
        self.name = geoObjectName
        self.dim = 1         
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            
        
        self.default = False
            
        self.entries = {}
        
        self.title("Koordinaten des Punktes")
           
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['Koordinaten']
        # default = 0.0
        # column = Spalte, row: Zeile
        ##### 1 Punkt
        wert = '0'
        a_ij = points[0] 
        for j in range(0,3):
            wert = '0'
            #print i,j
            if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                Label(master, text=a_ij,width=3*self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=0, column=j)
            self.entries[ j] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
            if self.edit:
                self.entries[j].insert(END, str( self.mtx[j] ) )
            else:
                self.entries[j].insert(END, str( wert ) )
            
            self.entries[ j].grid(row=0, column=2*j+1)
        # Name des Punktes => muehsam . . .        
        Label(master, text="Name",width=3*self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=2, column=0)
        self.entries[3] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[3].insert(END, self.name ) # Default-Name: self.name
        self.entries[3].grid(row=2,column=1, columnspan=6,sticky=E+W)

        self.resizable('0','0')  # window should not be resizable!
        
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()   #

        self.name = self.entries[3].get()
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,3):
                try:
                    zeile.append(util.r2f( self.entries[i + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None
            #print zeile
            self.mtx.append(zeile)
        
#################################
class VecPunkte(Dialog):   
    """Fenster für Vektor durch zwei Punkte"""
    def __init__(self,parent,geoObjectName,_title_ = None,dimension = None, _parameter_ = None): 
        self.dim = 2
        self.name = geoObjectName
        if _parameter_:
            #print _parameter_
            self.edit = 1
            self.mtx = []            
            for i in range(0,self.dim):
                for j in range(0,self.dim+1):
                    #print i,j
                    self.mtx.append( str(_parameter_[i][j]) )
            #print str(self.mtx)                    
        else:
            self.mtx = []
            self.edit = 0


        self.fensterTitel = _title_
        
        Dialog.__init__(self,parent,_title_) 


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
           
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        if (self.fensterTitel == "Tetraeder"):
            points = ['S','A']
        else:
            points = ['A','B']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim + 1):
                wert = '0'
                #print i,j
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*(self.dim + 1) + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:                    
                    self.entries[i*(self.dim + 1) + j].insert(END, self.mtx[i*(self.dim+1) + j] )
                else:
                    self.entries[i*(self.dim + 1) + j].insert(END, str( wert ) )
                                
                self.entries[i*(self.dim + 1) + j].grid(row=i, column=2*j+1)
        # Name des Vektors . . .        
        Label(master, text="Name",width=self.breite+1,justify=LEFT,font=myFont,anchor=W).grid(row=3, column=0)
        self.entries[6] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[6].insert(END, self.name ) # Default-Name: self.name
        self.entries[6].grid(row=3,column=1, columnspan=6,sticky=E+W)

            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        #print str(self.dim)
        self.name = self.entries[6].get()        
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim+1):
                try:
                    zeile.append(util.r2f( self.entries[i*(self.dim + 1) + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
##########################################################             
            
class Vektor(Dialog):   
    """Fenster für Eingabe eines Vektors"""    

    def __init__(self,parent,geoObjectName,_title_ = None,dimension = None,_koeff_ = None):
         if _koeff_:
             self.mtx = _koeff_
             self.edit = 1
         else:
             self.mtx = []
             self.edit = 0
	 self.dim = 3
	 self.name = geoObjectName
         Dialog.__init__(self,parent,_title_) 
    
    def body(self, master):            

        
        self.default = False
            
        self.entries = {}
        
        self.title("Vektor")
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0

        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            self.entries[i] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
            if self.edit:
                self.entries[i].insert(END, str( self.mtx[i] ) )
            else:
                self.entries[i].insert(END, str( wert ) )
            self.entries[i].grid(row=i, column=1)
            

        # Name des Vektors . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=3, column=0)
        self.entries[4] = Entry(master,width=self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[4].insert(END, self.name ) # Default-Name: self.name
        self.entries[4].grid(row=3,column=1, columnspan=4,sticky=E+W)
        
        self.resizable('0','0')  # window should not be resizable!    
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.name = self.entries[4].get()         
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        zeile = []
        for i in range(0,self.dim):            
            try:
                zeile.append(util.r2f( self.entries[i].get() ) )
            except:
                self.result = None
        #print zeile
        self.mtx.append(zeile)
        
                
 

##########################################################        
class kugel(ColorPicker):   
    """Fenster für Kugel mit Mittelpunkt M und Punkt O auf Oberfläche"""    
    def __init__(self,parent,geoObjectName,_colList_, _title_ = None,dimension = None,_parameter_ = None, colorIndex=0):
        
        self.colList = _colList_[:]
        self.dim = 2
        self.name = geoObjectName        
        
        if _parameter_:
            self.mtx = []
            #print _parameter_
            for i in range(0,self.dim):
                for j in range(0,self.dim+1):
                    #print i,j
                    self.mtx.append( str(_parameter_[i][j]) )            
            self.edit = 1
            #print self.mtx
        else:
            self.mtx = []
            self.edit = 0
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title("Kugel: Punkte M, O")
           
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['M','O']
        # default = 0.0
        for i in range(0,self.dim):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim + 1):
                wert = '0'
                #print i,j
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*(self.dim + 1) + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*(self.dim + 1) + j].insert(END, self.mtx[i*(self.dim+1) + j] )
                else:
                    self.entries[i*(self.dim + 1) + j].insert(END, str( wert ) )
                self.entries[i*(self.dim + 1) + j].grid(row=i, column=2*j+1)
        # Name der Kugel . . .        
        Label(master, text="Name",width=self.breite+1,justify=LEFT,font=myFont,anchor=W).grid(row=3, column=0)
        self.entries[6] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[6].insert(END, self.name ) # Default-Name: self.name
        self.entries[6].grid(row=3,column=1, columnspan=6,sticky=E+W)

            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        #print str(self.dim)
        self.color = self.colE.get()
        self.name = self.entries[6].get()        
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim):
            zeile = []
            for j in range(0,self.dim+1):
                try:
                    zeile.append(util.r2f( self.entries[i*(self.dim + 1) + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)
##########################################################             

##########################################################        
class rKugel(ColorPicker):   
    """Fenster für Kugel mit Mittelpunkt M und Radius r"""        
    def __init__(self,parent,geoObjectName,_colList_ ,_title_ = None,dimension = None, _mittelp_ = None, _radius_ = None, colorIndex=0):
        
        self.colList = _colList_[:]
        if _mittelp_:
            self.mtx = _mittelp_             
            self.radius = str(_radius_)
            self.edit = 1
             
        else:
            self.mtx = []
            self.edit = 0
         
        self.dim = 2
        self.name = geoObjectName
        #Dialog.__init__(self,parent,_title_)
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex) 


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title("Kugel: Mittelpunkt M, Radius R")
           
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['M','r']
        # default = 0.0
        for i in range(0,self.dim-1):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim + 1):
                wert = '0'
                #print i,j
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*(self.dim + 1) + j] = Entry(master,width=12,font=(self.font_type,self.font_size,'normal') )
                if self.edit:                    
                    self.entries[i*(self.dim + 1) + j].insert(END, str(self.mtx[j]) )
                else:
                    self.entries[i*(self.dim + 1) + j].insert(END, str( wert ) )
                self.entries[i*(self.dim + 1) + j].grid(row=i, column=2*j+1)
        # Radius r . . .        
        Label(master, text=points[1],width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=2, column=0)
        self.entries[5] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        if self.edit:            
            self.entries[5].insert(END, self.radius ) 
        else:            
            self.entries[5].insert(END, "1" ) # Default-Radius: 1
        self.entries[5].grid(row=2,column=1, columnspan=6,sticky=E+W)

        # Name der Kugel . . .        
        Label(master, text="Name",width=self.breite+1,justify=LEFT,font=myFont,anchor=W).grid(row=3, column=0)
        self.entries[6] = Entry(master,width=2*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[6].insert(END, self.name ) # Default-Name: self.name
        self.entries[6].grid(row=3,column=1, columnspan=6,sticky=E+W)

            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        #print str(self.dim)
        self.color = self.colE.get()
        self.name = self.entries[6].get()        
        self.radius = util.r2f( self.entries[5].get() )       
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim-1):
            zeile = []
            for j in range(0,self.dim+1):
                try:
                    zeile.append( util.r2f( self.entries[i*(self.dim + 1) + j].get()) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None            
            self.mtx.append(zeile)


##################################################################################
class Kugel4P(ColorPicker):      
    """Fenster für Kugel aus 4 Punkten"""   
    def __init__(self,parent,geoObjectName,_colList_, _title_ = None,dimension = None,_punkte_ = None, colorIndex=0):
        self.colList = _colList_[:]
	self.dim = 3
	self.name = geoObjectName
        if _punkte_:
            self.mtx = []
            self.edit = 1
            #print str(_punkte_)
            for j in range(0,self.dim+1):            
                for i in range(0,self.dim):
                    #print str(_punkte_[j][i])
                    self.mtx.append( str(_punkte_[j][i]) )
            #print str(self.mtx)            
        else:
            self.mtx = []
            self.edit = 0
            
        self.fensterTitel = _title_
        
        ColorPicker.__init__(self,parent,_title_, self.colList,colorIndex)


    
    def body(self, master):            

        self.resizable('0','0')  # window should not be resizable!
        
        self.default = False
            
        self.entries = {}
        
        self.title( self.fensterTitel )
        
        if os.name == 'posix': 
            self.font_size = 12
            self.breite = 4
            self.font_type = 'fixed'
        else:     
            self.font_size = 10
            self.breite = 4
            self.font_type = 'ansifixed'
        myFont =  (self.font_type,self.font_size,'normal')   
        offset = 0
        points = ['A','B','C','D']
        # default = 0.0
        for i in range(0,self.dim + 1):
            ##### 3 Punkte
            wert = '0'
            a_ij = points[i] 
            for j in range(0,self.dim ):
                #print i, j, i*self.dim + j
                wert = '0'
                
                if (j == 0): # nur in der mittlere Zeile wird etwas ausgegeben
                    Label(master, text=a_ij,width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                #else:                    
                #    Label(master, text=" ",width=self.breite,justify=LEFT,font=myFont,anchor=W).grid(row=i, column=2*j)
                self.entries[i*self.dim + j] = Entry(master,width=10,font=(self.font_type,self.font_size,'normal') )
                if self.edit:
                    self.entries[i*self.dim + j].insert(END, self.mtx[i*self.dim + j] )                    
                else:
                    self.entries[i*self.dim + j].insert(END, str( wert ) )
                self.entries[i*self.dim + j].grid(row=i, column=2*j+1)

        # Name des Tetraeders . . .        
        Label(master, text="Name ",width=self.breite+1,justify=LEFT,font=myFont,anchor=E).grid(row=self.dim + 1, column=0)
        self.entries[12] = Entry(master,width=3*self.breite,font=(self.font_type,self.font_size,'normal') )
        self.entries[12].insert(END, self.name ) # Default-Name: self.name
        self.entries[12].grid(row=self.dim + 1,column=1, columnspan=7,sticky=E+W)
            
        return self.entries[0] # initial focus   
                               
         
    def apply(self):
        self.result = 1
        self.color = self.colE.get()
        self.name = self.entries[12].get() 
        #print str(self.dim)
        self.mtx = [] # wichtig!!! globale Matrix mtx auf NULL [] setzen!
        for i in range(0,self.dim + 1):
            zeile = []
            for j in range(0,self.dim):
                #print i, j, i*self.dim + j
                try:
                    zeile.append(util.r2f( self.entries[i*self.dim + j].get() ) )
                    #print str(i*self.dim + j)
                except:
                    self.result = None
            #print str(zeile)
            self.mtx.append(zeile)
        #print str(self.mtx)
        

                


##################################################################################

