# -*- coding: utf-8 -*-
"""
Date: 2008-11-08
ws
"""

import os
import Tkinter
if os.name == 'posix':
    Tkinter.wantobjects = 0
    # tkMessageBox.askyesno wrong result under Linux!
    # see http://mail.python.org/pipermail/python-bugs-list/2004-September/025172.html

from Tkinter import *  
import tkMessageBox 
from tkFileDialog import *
# try: help(tkFileDialog)

import fileinput
import pymaxUtil as util


## font-type and font-size
## see also tkSimpleText.py
if os.name == 'posix':
    gf_font_art='bold'
    gf_font_type='courier'
    gf_font_size=10
    gf_font_type2=gf_font_type
else:
    gf_font_art='normal'
    gf_font_type2='courier'
    gf_font_type='courier'
    gf_font_size=10
gf_font=(gf_font_type,gf_font_size,gf_font_art)
## gf_font2 for parameter-window
gf_font2=(gf_font_type2,gf_font_size,gf_font_art)



class Dialog(Toplevel): 
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm   
    def __init__(self, parent, title = None): 
 
        Toplevel.__init__(self, parent) 
        self.transient(parent) 
 
        if title: 
            self.title(title) 
 
        self.parent = parent 
        
        self.result = None 

 
        body = Frame(self) 
        self.initial_focus = self.body(body) 
        body.pack(padx=5, pady=5) 
 
        self.buttonbox() 
 
        self.grab_set() 
 
        if not self.initial_focus: 
            self.initial_focus = self 
 
        self.protocol("WM_DELETE_WINDOW", self.cancel) 
 
        self.geometry("+%d+%d" % (parent.winfo_rootx()+50, 
                                  parent.winfo_rooty()+50)) 
 
        self.initial_focus.focus_set() 
 
        self.wait_window(self) 
 
    # 
    # construction hooks 
 
    def body(self, master): 
        # create dialog body.  return widget that should have 
        # initial focus.  this method should be overridden 
 
        pass 
 
    def buttonbox(self): 
        # add standard button box. override if you don't want the 
        # standard buttons 
         
        box = Frame(self) 
 
        w = Button(box, text="OK", width=10, command=self.ok, default=ACTIVE) 
        w.pack(side=LEFT, padx=5, pady=5) 
        w = Button(box, text="Cancel", width=10, command=self.cancel) 
        w.pack(side=LEFT, padx=5, pady=5) 
 
        self.bind("<Return>", self.ok) 
        self.bind("<Escape>", self.cancel) 
 
        box.pack() 
 
    # 
    # standard button semantics 
 
    def ok(self, event=None): 
 
        if not self.validate(): 
            self.initial_focus.focus_set() # put focus back 
            return 
 
        self.withdraw() 
        self.update_idletasks() 
 
        self.apply() 
 
        self.cancel() 
 
    def cancel(self, event=None): 
 
        # put focus back to the parent window 
        self.parent.focus_set() 
        self.destroy() 
 
    # 
    # command hooks 
 
    def validate(self): 
 
        return 1 # override 
 
    def apply(self): 
 
        pass # override 
 

###############################################   

class parameterfenster(Dialog):   
    # Quelle: F. Lundh: An Introduction to Tkinter, ch. 9: Dialog Windows   
    # http://www.pythonware.com/library/tkinter/introduction/index.htm   
   
    #global pgname, ini_dici         
    
    def __init__(self,parent,_pgname_ = None,_pyMaximaHome_ = None,_font_size_=10, _ini_dici_ = {}): 
        self.pgname = _pgname_
        #print self.pgname
        self.pyMaximaHome = _pyMaximaHome_
        #print self.pyMaximaHome
        self.ini_dici = {}
        util.kopiereDici( _ini_dici_,self.ini_dici)
        self.a1 = None
        self.a2 = None
        self.a3 = None
        self.a4 = None
        self.a5 = None        
        self.result = None
        self.padxValue = 5
        self.pfenster_font = (gf_font2[0],_font_size_,gf_font2[2]) #Parameter _font_size_ !!!
        #print self.pfenster_font
        #print str(self.list)	    
        Dialog.__init__(self,parent) 


    def body(self, master):      
        self.title( self.pgname + ": Einstellungen")
        
        self.breite = 16
        
        Label(master, text="Delay Time:    ",width=self.breite,justify=LEFT,font=self.pfenster_font,anchor=W).grid(row=0)   
        Label(master, text="Maxima-Pfad:   ",width=self.breite,justify=LEFT,font=self.pfenster_font,anchor=W).grid(row=1)
        Label(master, text="Maxima-Manual: ",width=self.breite,justify=LEFT,font=self.pfenster_font,anchor=W).grid(row=2)
        Label(master, text="Python-Pfad:   ",width=self.breite,justify=LEFT,font=self.pfenster_font,anchor=W).grid(row=3)

        listFrame = Frame(master)
        listFrame.grid(row=4,columnspan=2, sticky=W+E+N+S)#side=TOP, padx=5, pady=5)
                        
        self.e1 = Entry(master,width=60,font=self.pfenster_font )   
        self.e2 = Entry(master,width=60,font=self.pfenster_font )
        self.e3 = Entry(master,width=60,font=self.pfenster_font )
        self.e4 = Entry(master,width=60,font=self.pfenster_font )
        self.e5 = Entry(listFrame,width=6,font=self.pfenster_font )
        self.e6 = Entry(listFrame,width=6,font=self.pfenster_font )

        
        self.e1.insert(END, self.ini_dici.get('delay_time')) 
        self.e2.insert(END, self.ini_dici.get('maxima_path'))         
        self.e3.insert(END, self.ini_dici.get('docu_path'))
        self.e4.insert(END, self.ini_dici.get('py_path')) 
        self.e5.insert(END, self.ini_dici.get('font_size_para'))
        self.e6.insert(END, self.ini_dici.get('nr_lines_main'))
 
        self.e1.grid(row=0, column=1)   
        self.e2.grid(row=1, column=1)
        self.e3.grid(row=2, column=1)
        self.e4.grid(row=3, column=1)

        Label(listFrame, text="Font Size Parameter Window:",width=self.breite+13,justify=LEFT,font=self.pfenster_font,anchor=W).pack(side=LEFT)
        # das zweite Label muss zuletzt vereinbart werden!
        #Label(listFrame, text="Font Size Help Window:",width=self.breite+8,justify=LEFT,font=self.pfenster_font,anchor=W).pack(side=RIGHT)                
        self.e5.pack(side=LEFT)
        self.e6.pack(side=RIGHT) 
        Label(listFrame, text="Number of lines => Main-Window:",width=self.breite+16,justify=LEFT,font=self.pfenster_font,anchor=W).pack(side=RIGHT)        

        #Label(listFrame, text="Font Size Help Window:",width=self.breite+8,justify=LEFT,font=self.pfenster_font,anchor=W).pack(side=LEFT)        
        #self.e6.pack(side=LEFT)                

        self.dir_img = PhotoImage(file=self.pyMaximaHome+os.sep+'images'+os.sep+"dir.gif")       
        self.open_img = PhotoImage(file=self.pyMaximaHome + os.sep+'images'+os.sep+ "oeffnen.gif")       

        if os.name != 'posix': # win nt
            self.b2 = Button(master,image=self.dir_img,bd="2",relief=RIDGE,command=(lambda arg=self.e2: self.holeVerzeichnisname(arg) ) )          
            self.b3 = Button(master,image=self.dir_img,bd="2",relief=RIDGE,command=(lambda arg=self.e3: self.holeVerzeichnisname(arg) ) )
            self.b4 = Button(master,image=self.open_img,bd="2",relief=RIDGE,command=(lambda arg=self.e4: self.holeDateiname(arg) )  )
            self.b2.grid(row=1, column=2)
            self.b3.grid(row=2, column=2)
            self.b4.grid(row=3, column=2)
        else: # posix/linux
            self.b3 = Button(master,image=self.dir_img,bd="2",relief=RIDGE,command=(lambda arg=self.e3: self.holeVerzeichnisname(arg) ) )
            self.b3.grid(row=2, column=2)
            

        return self.e1 # initial focus   
                               
         
    def apply(self):   
        self.a1 = self.e1.get() 
        self.a2 = self.e2.get()
        self.a3 = self.e3.get()
        self.a4 = self.e4.get()
        self.a5 = self.e5.get()
        self.a6 = self.e6.get()        
        self.result = 1

    def holeVerzeichnisname(self,choosed_entry):           
        start_pfad = choosed_entry.get()
        eingabe = askdirectory(title=u'Verzeichnis w\xe4hlen',initialdir=start_pfad) 
        if eingabe <> '': 
            verzeichnis = os.path.abspath (eingabe)
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, verzeichnis)

    def holeDateiname(self,choosed_entry):           
        start_pfad = os.path.dirname( choosed_entry.get() )        
        #eingabe = askopenfilename(title=u'Python-Pfad',filetypes=[("python.exe","*.exe")],initialdir=start_pfad)
        eingabe = askopenfilename(title=u'Python-Pfad',filetypes=[("Alle Dateien","*.*")],initialdir=start_pfad)
        if eingabe <> '': 
            dateiname = os.path.abspath (eingabe)
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, dateiname)                 



##################################################################
  
class htmlFenster(Dialog): 
    # abgeleitet aus tkSimpleDialog
    

    def __init__(self,parent,_pgname_ = None,_pyMaximaHome_ = None,_workingDir_ = None,_font_size_=10): 
        self.pgname = _pgname_
        self.pyMaximaHome = _pyMaximaHome_
        self.workingDir = _workingDir_


        self.with_image = 0 # alternativ: self.with_image = 1
        self.a1 = None
        self.a2 = None
        self.ret_image = None
        self.result = None
        self.holeName = 0
        self.hfenster_font = (gf_font2[0],_font_size_,gf_font2[2]) #Parameter _font_size_ !!!        
        #print str(self.list)	    
        Dialog.__init__(self,parent) 
    

    def body(self, master):
        #global ini_dici
        self.title( self.pgname + ": Export2HTML")        

        self.breite = 12


        self.ret_image = IntVar(master)
        self.ret_image.set(self.with_image)
        Checkbutton(master,variable=self.ret_image).grid(row=1, column=0) 
        self.ret_image.trace('w',self.changed )

        Label(master, text="HTML-Datei: ",width=self.breite,justify=LEFT,font=self.hfenster_font,anchor=W).grid(row=0, column=1)   
        Label(master, text="png-Datei:   ",width=self.breite,justify=LEFT,font=self.hfenster_font,anchor=W).grid(row=1, column=1)
    

        self.e1 = Entry(master,width=60,font=self.hfenster_font )   
        self.e2 = Entry(master,width=60,font=self.hfenster_font,state=DISABLED )


        self.e1.insert(END, "") 
        self.e2.insert(END, "")         

 
        self.e1.grid(row=0, column=2)   
        self.e2.grid(row=1, column=2)
                

        self.open_img = PhotoImage(file=self.pyMaximaHome + os.sep+'images'+os.sep+ "oeffnen.gif")       


        self.b1 = Button(master,image=self.open_img,bd="2",relief=RIDGE,command=(lambda arg=self.e1: self.holeDateinameHTML(arg) ) )          
        self.b2 = Button(master,image=self.open_img,bd="2",relief=RIDGE,state=DISABLED, command=(lambda arg=self.e2: self.holeDateinameBILD(arg) ) )

        self.b1.grid(row=0, column=3)
        self.b2.grid(row=1, column=3)

            
        return self.e1 # initial focus   
                               



    def apply(self):   
        self.a1 = self.e1.get() 
        self.a2 = self.e2.get()
        self.a3 = self.ret_image.get() 
        self.result = 1


    def holeDateinameHTML(self,choosed_entry):           
        #start_pfad = os.path.dirname( choosed_entry.get() )
        start_pfad = self.workingDir
        eingabe = asksaveasfilename(filetypes=[('HTML', "*.html *.htm"),("Alle Dateien","*.*")],initialdir=start_pfad)
        if eingabe <> '': 
            dateiname = os.path.abspath (eingabe)
            if ( (not util.test_extension(dateiname,".html")) and (not util.test_extension(dateiname,".htm")) ):
                testname = dateiname + ".html"
            else:
                testname = dateiname            
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, testname)
            self.holeName = 1
            self.workingDir = os.path.abspath(os.path.dirname( choosed_entry.get() )) + os.sep 


    def holeDateinameBILD(self,choosed_entry):           
        #start_pfad = os.path.dirname( choosed_entry.get() )
        start_pfad = self.workingDir
        eingabe = askopenfilename(filetypes=[('jpg/png', "*.jpg *.png"),("Alle Dateien","*.*")],initialdir=start_pfad)
        if eingabe <> '': 
            dateiname = os.path.abspath (eingabe)
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, dateiname)                 

 
    def changed(self,*args):
        if (self.ret_image.get() == 1):
            self.e2.config(state=NORMAL)
            self.b2.config(state=NORMAL)
        else:
            self.e2.config(state=DISABLED)
            self.b2.config(state=DISABLED)



class texFenster(Dialog): 
    # abgeleitet aus tkSimpleDialog
    

    def __init__(self,parent,_pgname_ = None,_pyMaximaHome_ = None,_workingDir_ = None,_font_size_=10): 
        self.pgname = _pgname_
        self.pyMaximaHome = _pyMaximaHome_
        self.workingDir = _workingDir_

        self.with_image = 0 # alternativ: self.with_image = 1
        self.a1 = None
        self.a2 = None
        self.ret_image = None
        self.result = None
        self.holeName = 0
        self.hfenster_font = (gf_font2[0],_font_size_,gf_font2[2]) #Parameter _font_size_ !!!        
        #print str(self.list)	    
        Dialog.__init__(self,parent) 
    

    def body(self, master):
        #global ini_dici
        self.title( self.pgname + ": Export2TEX")        

        self.breite = 12


        self.ret_image = IntVar(master)
        self.ret_image.set(self.with_image)
        Checkbutton(master,variable=self.ret_image).grid(row=1, column=0) 
        self.ret_image.trace('w',self.changed )

        Label(master, text="TEX-Datei: ",width=self.breite,justify=LEFT,font=self.hfenster_font,anchor=W).grid(row=0, column=1)   
        Label(master, text="png-Datei:   ",width=self.breite,justify=LEFT,font=self.hfenster_font,anchor=W).grid(row=1, column=1)
    

        self.e1 = Entry(master,width=60,font=self.hfenster_font )   
        self.e2 = Entry(master,width=60,font=self.hfenster_font,state=DISABLED )


        self.e1.insert(END, "") 
        self.e2.insert(END, "")         

 
        self.e1.grid(row=0, column=2)   
        self.e2.grid(row=1, column=2)
                

        self.open_img = PhotoImage(file=self.pyMaximaHome + os.sep+'images'+os.sep+ "oeffnen.gif")       


        self.b1 = Button(master,image=self.open_img,bd="2",relief=RIDGE,command=(lambda arg=self.e1: self.holeDateinameTEX(arg) ) )          
        self.b2 = Button(master,image=self.open_img,bd="2",relief=RIDGE,state=DISABLED, command=(lambda arg=self.e2: self.holeDateinameBILD(arg) ) )

        self.b1.grid(row=0, column=3)
        self.b2.grid(row=1, column=3)

            
        return self.e1 # initial focus   
                               



    def apply(self):   
        self.a1 = self.e1.get() 
        self.a2 = self.e2.get()
        self.a3 = self.ret_image.get() 
        self.result = 1


    def holeDateinameTEX(self,choosed_entry):           
        #start_pfad = os.path.dirname( choosed_entry.get() )
        start_pfad = self.workingDir
        eingabe = asksaveasfilename(filetypes=[('TEX', "*.tex"),("Alle Dateien","*.*")],initialdir=start_pfad)
        if eingabe <> '': 
            dateiname = os.path.abspath (eingabe)
            if ( (not util.test_extension(dateiname,".tex"))):
                testname = dateiname + ".tex"
            else:
                testname = dateiname
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, testname)
            self.holeName = 1
            self.workingDir = os.path.abspath(os.path.dirname( choosed_entry.get() )) + os.sep 


    def holeDateinameBILD(self,choosed_entry):           
        #start_pfad = os.path.dirname( choosed_entry.get() )
        start_pfad = self.workingDir
        eingabe = askopenfilename(filetypes=[('jpg/png', "*.jpg *.png"),("Alle Dateien","*.*")],initialdir=start_pfad)
        if eingabe <> '': 
            dateiname = os.path.abspath (eingabe)
            choosed_entry.delete(0,END)         
            choosed_entry.insert(END, dateiname)                 

 
    def changed(self,*args):
        if (self.ret_image.get() == 1):
            self.e2.config(state=NORMAL)
            self.b2.config(state=NORMAL)
        else:
            self.e2.config(state=DISABLED)
            self.b2.config(state=DISABLED)



